About TestTrack Pro

Welcome to TestTrack Pro!

You have an important job to do - deliver a quality product on time and within budget. And, whether you are developing, testing, fixing bugs, or managing the team, you do not have time to learn another complex application. TestTrack Pro helps you control your bug tracking process. Design a complex tracking structure, or simply install the software, and start tracking the TestTrack Pro way!


What’s new in TestTrack Pro 6.0?

Introducing the Seapine License Server

The Seapine License Server is a client/server application that manages user licenses for all Seapine products. It also contains product-independent user demographic information for users and customers that is shared across Seapine products. All product servers connected to a license server can share the licenses and users that reside on that server.

No more choosing between Web and Windows clients

TestTrack Pro 6.0 users can log in from Web or Windows clients without purchasing separate licenses, saving money and giving your users the choice of how they access TestTrack Pro. The Web and Windows clients support both named and floating licenses, providing maximum licensing flexibility.

Fully customizable workflow

TestTrack Pro 6.0’s fully customizable workflow lets you define states, events, and state transition rules. In version 6.0, you can model your most complex workflow processes. TestTrack Pro 6.0 can even diagram the workflow for you.

Multiple users assignments

Need to assign a fixed defect to your QA team for verification? TestTrack Pro 6.0 can handle this and other group assignment tasks with ease. Need everyone in the group to sign off before moving the issue to a new state? TestTrack Pro 6.0 handles this too, giving you more control over your process.

Enhanced email notifications

TestTrack Pro 6.0 provides more control over who receives email notifications for specific events, products, issue types, and more. Version 6.0 also includes an unlimited number of customizable email templates and supports HTML-based email.

Even better custom field support

You can now define up to 100 custom fields for your issues. And, TestTrack Pro 6.0’s enhanced SOAP API supports full access to custom fields.

Additional fields in events

Issue event records now support file attachments, custom fields, and time tracking fields, giving you more control over the fields defined for each event.

Even more

TestTrack Pro 6 has even more features, including additional password security options for user accounts, 512-bit encrypted client/server communication, and additional automatic assignment rules.


Documentation conventions

The documentation, and most of the examples, are based on the default TestTrack Pro workflow. There are a few conventions used throughout the guide that are designed to be completely predictable – making it is easy to understand what you are reading and what you’re supposed to do. Many of the TestTrack Pro commands are available from menus, toolbars, shortcut menus, and shortcut keys. Throughout this guide, most commands are explained using both the menu command and the toolbar button. As you become more familiar with TestTrack Pro, you may find shortcut menus and shortcut keys more efficient to work with. When you are instructed to select a menu command, you will find the menu name, followed by an arrow. For example, to add a defect, choose Create > Defect. Indented text is also used to draw attention to notes, tips, examples, etc.


Before you start

This guide assumes your PC, printer, and network (if applicable) are set up and ready to use. It also assumes you know how to perform the basic skills needed to use them. If you need more information on basic features, refer to the user guide that came with your computer.


Contacting Seapine support

Telephone: 513-754-1655

Email : support@seapine.com

Web site : http://www.seapine.com

Note: Check our web site for the latest news and updates. You can also find help in our Knowledgebase!

Documentation feedback

Seapine Software welcomes your feedback on the documentation included with this product. If you have comments or suggestions about the documentation, please email: documentation @seapine.com. This email address is provided for documentation only. You may not receive a reply to your email. For technical questions or support, contact support@seapine.com.

© Copyright Seapine Software, Inc. 1996-2003


Getting Started

Start Tracking!

In just a few minutes, you’ll learn about starting TestTrack Pro, opening databases, and connecting to the server - everything you need to begin tracking bugs!


Starting the TestTrack Pro server

Note: Remember, the Seapine License Server must be running before you start the TestTrack Pro server.

The server must be running before users can access TestTrack Pro databases. The server can be run as an application, as a Windows service, or as a Windows pseudo service. Refer to the TestTrack Pro Installation Guide for more information.

If the TestTrack Pro server is running as a Windows service, it starts automatically. If the TestTrack Pro server is running as an application, the server must be started manually.

Manually starting the TestTrack Pro server

  1. On the Start menu, choose Programs > TestTrack Pro > TestTrack Pro Server.

    2. Active databases are loaded when the TestTrack Pro server is started.

    When the TestTrack Pro server is running, an icon is placed in the server PC’s status bar. If the bug is green, the server is running correctly. If the bug is yellow or red, the server is not running correctly.


Starting TestTrack Pro

  1. On the Start menu, choose Programs > TestTrack Pro > TestTrack Pro Client.

    2. The Login dialog box opens.

  2. Enter your Username and Password.
  3. Select a database from the Database list and click OK.

    4. You are logged in and ready to start using TestTrack Pro.

  4. If there is a problem connecting to the server, check the following and try reconnecting to the server:
    • Double-check the IP address and/or port number.
    • Make sure you are connected to the network, intranet, or Internet.
    • Contact your TestTrack Pro administrator for help.

      • If you are the TestTrack Pro administrator, check the following:

    • Make sure the server computer is on.
    • Make sure the TestTrack Pro Server application is running on your server computer.


Initially starting TestTrack Pro

  1. The first time you start TestTrack Pro, the Welcome to TestTrack Pro dialog box opens.

    2. The Welcome to TestTrack Pro dialog box opens.

  2. Enter your Name and Organization.
  3. Click OK.

    4. The Server Connection dialog box opens.

  4. Select a server from the Connect to TestTrack Pro Server list.
    5. Note: If the list is not populated, you need to configure the server connections. See Setting up server connections.
  5. Select Always connect to this server to automatically connect to the selected server.
  6. Click Connect.

    7. The Login dialog box opens.

  7. Enter your Username and Password.
  8. Select a database from the Database list and click OK.

    9. You are now ready to start using TestTrack Pro.

    Did you know? Where do I start?

    If you are the Project Manager, start with the Defects list to view all the defects in the database. Next, create filters to view specific defects. For example, create a filter that displays all defects currently in an Open state. You may also want to print a report that lists all defects opened in the past week.

    If you are the Lead Engineer, start with the Defects list. Create a filter that displays all defects created, fixed, or verified in the last week and are not currently assigned and not in the closed state. Then, assign the defects to the appropriate person.

    If you are an Engineer/Developer, start with the Workbook. The Workbook displays all the defects assigned to you and any to do tasks you added. You can also start with the Defects list and create a filter to displays only the defects assigned to you.

    If you are the Lead QA person, start with the Defects list and create a filter that displays all defects that are currently released to testing. Then, assign these defects to a QA team member for verification. You can also create a filter that displays defects that failed verification.

    If you are a member of the QA team, start with the Workbook. The Workbook displays all the defects assigned to you and any to do tasks you added. If you need to add new defects, start with the Defects list.


Setting up server connections

Server connections, used to access TestTrack Pro databases, need to be set up. The TestTrack Pro administrator can enter server connection information using the Server Admin Utility or users can set up server connections. Depending on your company’s process, you may be required to set up server connections.

Adding server connections

The databases you use can be located on different servers. You need to add a server connection to access the TestTrack Pro server.

  1. Choose File > New Server Connection.

    2. The Server Connection dialog box opens.

  2. Click Setup.

    3. The Setup Server Configurations dialog box opens.

  3. Click Add.

    4. The Add TestTrack Pro Server dialog box opens.

  4. Enter a Server Name and Server Address.

    5. The server address is the IP address of the computer where the TestTrack Pro server application is installed. Your TestTrack Pro administrator can tell you the server address.

  5. Enter the Port number.

    6. TestTrack Pro clients connect to the server on this port via TCP/IP. Valid values are 1-65535. The default value is 99.

  6. Click OK.

    7. The server connection is added. You return to the Setup Server Configurations dialog box. To change the order of the servers, select a server entry and click Up or Down.

  7. Click Close to close the Setup Server Configurations dialog box.

Editing server connections

  1. Choose File > New Server Connection.
  2. Click Setup.
  3. Select the server and click Edit.
  4. Make any changes and click OK.

Deleting server connections

  1. Choose File > New Server Connection.
  2. Click Setup.
  3. Select the server and click Delete.

    4. You are prompted to confirm the deletion.

  4. Click Yes.

    5. The server is deleted.


Opening a database

Use this command to open a database that is located on the server you are connected to.

  1. Choose File > Open Database or click the Open Database toolbar button.

    2. You are prompted to close the open database.

  2. Click Yes.

    3. The Login dialog box opens.

  3. Enter your Username and Password.
  4. Select a database from the Database list and click OK.


Connecting to a server

Use this command to connect to a different server and open a database on that server.

  1. Choose File > New Server Connection.

    2. The Server Connection dialog box opens.

    If you are logged in to a database, you are prompted to close the database. Click Yes.

  2. Select a server from the Connect to TestTrack Pro Server list and click Connect.

    3. The Login dialog box opens.

  3. Enter your Username and Password.
  4. Select a database from the Database list and click OK.


Viewing project information

You can view information about the database you are logged in to.

  1. Choose Help > Project Info.

    2. The Project Information dialog box opens. It includes the project name, description, and creation date.

  2. Click OK to close the dialog box.


Logging out

Logout of TestTrack Pro when you finish working with defects. This is important if your company uses floating licenses. The license you are using is not available to other users until you logout.

  1. Choose File > Logout and Disconnect.

    2. You are logged out from the database and disconnected from the server.

    Tip: To close the TestTrack Pro application, choose File > Exit.


Personalizing TestTrack Pro

Up Close and Personal!

Take the time personalize TestTrack Pro and set the options that will make your job easier!


Setting local options

Local options are global. You do not need to log in to a specific database to set these options.

  1. Choose Edit > Options > Local Options.

    2. The Local Options dialog box opens with the General tab selected.

  2. Select the general options.
    • Select Show the Server Connection Dialog if you connect to different servers. When you start TestTrack Pro, the server connection dialog box opens so you can choose a server.
    • Select Always connect to the last TestTrack server if you always connect to the same server.
    • Select Automatically log last user into last database if security is not a concern. You are automatically connected to the server and logged in to the last database used.
    • Select Allow multiple instances of this application if you want to login to different databases at the same time. You can open multiple instances of TestTrack Pro.
  3. Click the Stylesheets tab to select the default stylesheet you want to use when printing from list windows.
  4. Select a Report Type from the list.

    5. Each Report Type corresponds to a list window. For example, the Filter View Detail Report prints a detail report for all filters in the database.

  5. Select a Default Stylesheet for the selected report or click Browse to use a customized stylesheet.

    6. For more information, see Using stylesheets.

  6. Click OK to save the local options you set.


Setting general user options

User options are database-specific and only affect the database you are logged in to.

  1. Choose Edit > Options > User Options.

    2. The User Options dialog box opens with the General tab selected.

  2. Select a Notification Option.

    3. TestTrack Pro can either play a sound or open a dialog box to notify you of defect assignments. You can also clear both options.

  3. Select a Double-clicking on items... option.

    4. This option affects records displayed on list windows. For example, you set this option to open the edit dialog box. If you double-click a user on the Users list window, the Edit User dialog box opens.

  4. Select a Display names as... option.

    5. Names can be displayed on First/Last or Last/First order.

  5. Select a Status option.

    6. You can display the status or the status and the assignment information.

  6. Select a Display option.
    • Select Grey out closed defects if you want closed defects to appear dimmed on the list window. If you work with a large number of defects, this option can help you quickly view closed defects.
    • If the database uses field relationships, select Warn me when values are changed due to field relationship rules to display a warning if you change a value that affects field relationship rules. This option helps enforce field relationship rules.
    • You can also clear both options.
  7. Select an Adding Multiple Defects option.

    8. This option affects the Add Defect dialog box and the action that is applied when you are adding new defects.

    • Select Set all fields to default values if you want fields on the Add Defect dialog box reset with their default values.
    • Select Retain pop-up menu values, but set other fields to their default values to keep the values you choose for pop-up fields and reset all other fields with default values. Pop-up fields include: Type, Product, Disposition, Priority, Component, and Severity. The other fields include: Entered By, Found By, Version Found, Reproduced, Computer Config, and Custom fields.
    • Select Close the Add Defect window if you want the Add Defect dialog box to close after a defect is added.


Configuring email notifications

Email notifications provide a way to stay up to date with changes to defects. Select options carefully so you do not receive an email each time a defect moves to another state in the workflow. You can also select filters to further restrict the email notifications you receive. You may also receive system notifications, which the TestTrack Pro administrator configures.


Adding notification rules

  1. Choose Edit > Options > User Options.
  2. Click the Email tab.
  3. Click Configure Rules.

    4. The Configure User Notification Rules dialog box opens. The notification name is listed in the top left corner of the dialog.

  4. Click Add to add a rule.

    5. The Add Notification Rule dialog box opens.

  5. Enter a Rule Name.
  6. Optionally select a Rule Filter.

    7. If a database contains a large number of defects, you may want to filter the defects the rule is applied to. If you need to add filters, see Creating filters.

  7. Select an Email Template.
  8. Select Don’t send email if I made the change if you do not want to receive an email if you changed the defect.
  9. Select Only send email if defect is assigned to me if you only want to receive an email if you are the assigned user.
  10. Click OK.

    11. The rule is added.


Editing notification rules

  1. Choose Edit > Options> User Options.

    2. The User Options dialog box opens.

  2. Click the Email tab.
  3. Click Configure Rules.
  4. Select a rule and click Edit.
  5. Make any changes and click OK.

    6. The changes are saved.


Inactivating notification rules

If there is a rule that is no longer in use, inactivate it instead of deleting it. You can easily activate the rule if you decide to use it again.

  1. Choose Edit > Options> User Options.

    2. The User Options dialog box opens.

  2. Click the Email tab.
  3. Click Configure Rules.
  4. Select a rule and click Inactivate.

    5. The rule is inactivated.

    Note: To activate an inactive rule, select the rule and click Activate.


Deleting notification rules

Delete rules if you are certain you will not use the rule again. You can also inactivate a rule to disable it.

Note: Make sure you want to delete the rule. You are not prompted to confirm the deletion and this action cannot be undone.
  1. Choose Edit > Options> User Options.

    2. The User Options dialog box opens.

  2. Click the Email tab.
  3. Click Configure Rules.

    4. The Configure Rules dialog box opens.

  4. Select a rule and click Delete.

    5. The rule is deleted.


Setting passwords

  1. Choose File > Set Password.

    2. The New Password dialog box opens.

  2. Enter a password and click OK.

    3. The Verify Password dialog box opens.

  3. Retype the password and click OK.


Changing passwords

  1. Choose File > Set Password.

    2. The Old Password dialog box opens.

  2. Enter your old password and click OK.

    3. The New Password dialog box opens.

  3. Enter a new password and click OK.

    4. The Verify Password dialog box opens.

  4. Retype the password and click OK.

    5. The password is saved.


Removing passwords

  1. Choose File > Set Password.

    2. The Old Password dialog box opens.

  2. Enter your old password and click OK.

    3. The New Password dialog box opens.

  3. Leave the field blank and click OK.

    4. The Verify Password dialog box opens.

  4. Leave the field blank and click OK.

    5. The password is removed.


Learning the Basics

Take a tour!

TestTrack Pro is easy to use, but it is even easier when you understand the basics and learn a few shortcuts. Take a few minutes to read this overview information.


TestTrack Pro interface

TestTrack Pro provides complex functionality with an easy to use, and learn, interface. The interface includes eight list windows. Features, such as the title bar, command buttons, menu bar, toolbar, status bar, and tooltips are common to all list windows. Some features and options, such as active menus and commands, depend on the list window and your security permissions.

Title bar

Lists the name of the open database or the name of the open list window.

Menu bar

Contains the available menus. Menu commands vary depending on the function you are performing, your security permissions, and the list window you are working on. If a menu command is unavailable, you do not have access to that command or the command is not available for the list window you are on.

Toolbar

Provides access to TestTrack Pro commands and list windows.

Command buttons

Located at the top of every list window, these buttons provide another way to access the View, Add, Edit, and Delete commands.

Status bar

Includes information such as the number of defects assigned to you or a toolbar button description.

Tooltips

When you place the cursor over a toolbar button, a command description opens.


TestTrack Pro toolbar

The toolbar contains buttons that give you access to TestTrack Pro commands and list windows—just a click away!

Click | To do this...
 | Open a database
 | Open the Print Option dialog box
 | Open the Find Defects dialog box
 | Open the Advanced Find Defects dialog box
 | Open the Defects list window
 | Open the Customers list window
 | Open the Test Configs list window
 | Open the Users list window
 | Open the User Groups list window
 | Open the Filters list window
 | Open the Reports list window
 | Open the Workbook list window

Tip: You can also access these commands from TestTrack Pro menus. For example, to open the Defects list window, choose View > Defects.


List windows

List windows are used to display basic record information. TestTrack Pro includes the following list windows: Defects, Customers, Users, User Groups, Test Configs, Filters, Reports, and Workbook.

Opening list windows

Click the corresponding TestTrack Pro toolbar button. Or select the list window you want to open from the View menu.

Selecting records

Before you can work with records, you need to select the records on the list window.

  • To select all records, choose Edit > Select All or press Ctrl + A.
  • To select more than one record, hold down the Ctrl key while clicking the records.
  • To select a range of records, click the first record, then hold down the Shift key and click the last record.

Defects list window

The Defects list window provides access to defects and defect actions. For more information, see Working with Defects.

This list window also includes defect indicates that point out new, changed, and closed defects and the defects assigned to you. You can also filter the records that are displayed in the list window.

Defect indicators

Defect indicators are icons on the Defects list window that point out new defects, changed defects, closed defects, and the defects that are assigned to you.

Icon | Name | Indicates
 | New Defect | Defects added since you last logged in
 | Changed Defect | Defects that changed since you last logged in
 | Closed Defect | Closed defects
 | Assigned Defect | Defects assigned to you

Customers list window

The Customers list window provides access to customers and customer commands. For more information, see Managing Customers.

Users list window

The Users list window provides access to users and user commands. For more information, see Managing Users.

User groups list window

The User Groups list window provides access to user groups and user group commands. For more information, see Managing User Groups.

Test configs list window

The Test Configs list window provides access to test configs and test config commands. For more information, see Managing Test Configs.

Filters list window

The Filters list window provides access to filters and filter commands. For more information, see Using Filters.

Reports list window

The Reports list window provides access to reports and reports commands. For more information, see Generating Reports.

Workbook list window

The Workbook list window provides access to your personal workbook, your assigned defects, and tasks you add to the Workbook. For more information, see Using the Workbook.


Adding columns

List window information is displayed in a column format. This lets you customize the information that is displayed. For example, you can add and remove columns or sort columns to easily view information that’s important to you.

  1. Right-click the column heading you want to add a column next to.
  2. Select Insert Column from the shortcut menu. An empty column is added to the left of the selected column.
  3. Select a field name to add column contents.


Adding column contents

To add or change column contents, select a new field for the column.

  1. Right-click the column heading you want to change.

    2. The shortcut menu lists all the available fields.

  2. Select the field name from the menu.

    3. The column heading changes to the field name and the selected field contents are displayed.


Sorting columns

You can sort by any column and you can perform primary and secondary sorts.

  • To sort a primary column, click the column heading. A single tick mark appears to the right of the column heading. Click the column heading again to toggle the sort order between ascending and descending.
  • To sort a secondary column, Shift+click the column heading. Two tick marks appear to the right of the column heading. Shift + click the column heading again to toggle the sort order between ascending and descending. For example, the following list is sorted first by Status and then by Product.


Changing column widths

To make a column wider or narrower:

  1. Move the cursor to the divide bar located between the column headings.

    2. The cursor changes to a resize cursor.

  2. Click and drag the divide bar to change the width of the column to the left of the divide bar.


Removing columns

  1. Right-click the column heading you want to remove.
  2. Select Remove Column from the shortcut menu.


Printing

Note: If you do not want to print every record in the list, select the items you want to print on the list window. Make sure you select the Only Print Selected Items check box on the Print Options dialog box!
  1. Choose File > Print or click the Print toolbar button.

    2. The Print Options dialog box opens.

  2. Select print options.
    • Print as list prints all the records in a list format.
    • Print as detail prints the details for each record.
    • Create report file from template lets you print a report based on a previously created template. After choosing this option, click Save (the Print buttons changes to a Save button). The Select Report Template dialog box opens. Select the report template you want to use and click Open. The Save Report As dialog box opens. Select a directory and enter a filename. The report is saved as a text document.
  3. Click Print.

    4. You can also click Preview to open the report in preview mode.


Working with Defects

Squash the bugs...

...and move on! You’ll be tracking defects in no time at all, after learning about adding defects, deleting defects, and everything in between.


About defects

A defect is a bug, enhancement, change request, question, or any other product-related issue you need to track and resolve. It can be as simple as a typo in a Help file or as complicated as a system crash. Depending on your needs, you can configure complex tracking methods or simply use TestTrack Pro as a “to do” list.


Adding defects

  1. Choose Create > Defect or click Add on the Defects list window.

    2. The Add Defect dialog box opens. This dialog box includes the following tabs: Detail, Workflow, Workaround, Source Code, Notify, History, and an optional Custom Fields tab.

    The Detail tab includes 4 mini tabs: Found By, Reproduce, Computer Config, and Attachments.

    Note: The New and Remove buttons on the Detail tab are used to add or remove additional defect reports. See Adding additional defect reports.
  2. Enter the information in the top portion of the Add Defect dialog box.
    • Enter a defect summary. You can enter up to 255 characters.
    • Status displays the what state the defect is in and whether it is assigned.
    • Select the defect disposition.
    • Select the defect type.
    • Select the defect priority.
    • Select the product.
    • Select the component.
    • Optionally enter a reference number pertinent to the defect.
    • Select the defect severity.
    • Entered by defaults to the current user or you can select another user.
    • Date Entered defaults to the current date or you can enter another date.
  3. Enter the information on the Detail: Found by mini tab.
    • Found by defaults to the current user or you can select another user. To search for a user or customer, click the Find button located next to the Found by field. Enter the search criteria. If matching users or customers are found, select one to populate the Found by field.
    • Date defaults to the current date or you can enter another date.
    • Select the version of the software containing the defect.
    • Enter a detailed defect description.
  4. Enter the information on the Detail: Reproduce mini tab.
    • Select a reproduced level.
    • Enter the detailed steps to reproduce the defect. This information helps programmers, testers, etc., fix and test the defect.
  5. Enter the information on the Detail: Computer Config mini tab.
    • Select a computer configuration. The default is the current user’s configuration.
    • Enter information about other hardware and software that could be affecting the problem.
  6. If necessary, attach a file to the defect using the Detail: Attachments mini tab. For more information, see Attaching files.
  7. Optionally, click the Custom Fields tab.
    8. Note: You may not have access to this tab, depending on your security permissions and the database configuration.

    If a database uses custom fields, up to two custom fields may be displayed in the main area of the Add Defect dialog box. Custom fields can also all be displayed on the Custom Fields tab – make sure you click this tab to enter or check custom field information.

  8. Skip the Workflow tab.

    9. This tab is populated with defect event information and is useful when editing or viewing defects.

  9. Click the Workaround tab.

    10. Enter a workaround solution for the bug that can be used until it is fixed or implemented.

  10. Skip the Source Code tab.

    11. This tab is used for SCC application functions. Most users do not attach source code files while adding defects. For more information, see Integrating SCC applications.

  11. Click the Notify tab.
    • To add users or customers to the notification list, click Add.
    • Select the users or customers from the Add Mail Recipients dialog box and click Add.
    • To remove users, highlight the user /customer and click Remove.
  12. Skip the History tab.

    13. This tab is populated with defect historical information and is useful when editing or viewing defects.

  13. When you finish entering information, click Add on the Add Defect dialog box.

    14. The defect is added to the database.


Adding additional defect reports

Users, customers, or beta sites often report the same defect. To eliminate duplicates in your database, you should add the defect once and add all additional reports to the same defect.

  1. Edit the defect you want to add an additional report to.
  2. Choose Activities > New Reported By.

    3. You can also click New on the Detail tab.

  3. Enter the additional report information.

    4. For more information, see Adding defects.

  4. Click OK when you finish adding the additional report.
    5. Note: The Detail tab includes a counter. If a defect is reported multiple times, the counter increases and shows the number of times the defect is reported.


Attaching files

When you add a defect, you can attach related files. For example, if a defect is corrupting a file, you can attach the corrupt data file for reference. If you want to point out a cosmetic changes to a dialog box, you can attach a screen shot that includes the changes.

Tip: You can attach multiple files to a defect. You can also attach zipped files.
  1. Select the defect you want to attach a file to.
  2. Choose Edit > Edit Defect.
  3. On the Detail tab, click the Attachments mini tab.
  4. Click Attach.

    5. The Attach File dialog box opens.

  5. Navigate to the directory containing the file, select the file and click Open.

    6. The file is attached to the defect.


Finding defects

You can search against the summary field, the description field, or all notes. If you do not have security access to these fields, the Find Defects command is disabled.

Tip: If you know the number of a defect, you can jump directly to that defect. Choose Edit > Go To Defect Number, enter the defect number, and click OK.
  1. Choose Edit > Find Defects.

    2. The Find Defects dialog box opens.

  2. Select the search field from the Find list.

    3. Fields you have security access to are listed.

  3. Enter the text you want to search for in the Contains field.

    4. Select Based on Current Filter if you only want to search the filtered defects.

  4. Click Find. If matching defects are found, the search results are displayed on the Defects list window. Notice the Find Results filter is applied.
  5. If matching defects are not found, a warning message opens. Click OK.

    6. You return to the Defects list window, which is empty since no defects matched the search criteria. Notice the Find Results filter is applied.


Go to command

If you know the number of a specific defect, use the go to command to quickly find the defect.

  1. Choose Edit > Go To Defect Number.

    2. The Go To Defect Number dialog box opens.

  2. Enter the defect number and click OK.

    3. The corresponding defect is opened.


Using advanced find

Advanced find lets you perform a more powerful search using filters and Boolean logic. You can also search on multiple restrictions. For more information, see Using Filters.

  1. Choose Edit >Advanced Find Defects or click the Advanced Find toolbar button.

    2. The Advanced Find Defects dialog box opens.

    Note: If the defects are filtered, and you choose Advanced Find, the Advanced Find Defects dialog box is populated with the filter restrictions. Click Clear to remove the restrictions.
  2. Click Add to add a search restriction.

    3. The Restriction dialog box opens.

  3. Select the Restrict By field.

    4. When you select a Restrict By field, the restrictions you can set for the field appear in the Restrictions box.

  4. Select the restriction options.

    5. The restriction is added to the search.

  5. Click OK.

    6. You return to the Advanced Find Defects dialog box.

  6. Optionally, select NOT/AND/OR operators and parentheses to build the boolean logic for the filter. For more information, see About Boolean searches.
  7. Click Validate to validate the search criteria.
    • If the criteria is valid, click OK.
    • If the criteria is not valid, an error message opens. Click OK to return to the Advanced Find Defects dialog box and correct the error.
    • Click Clear to clear all restrictions and start over.
  8. Click Make Filter to save the search criteria as a filter. For more information, see Creating filters.
  9. When you finish adding restrictions and the criteria is validated, click Execute.
  10. If matching defects are found, the search results are displayed on the Defects list window. Notice the Find Results filter is applied.
  11. If matching defects are not found, a warning message opens.

    12. You return to the Defects list window, which is empty because matching defects were not found. Notice the Find Results filter is applied.


Viewing defects

  1. Select the defect on the Defects list window.
  2. Choose Edit > View Defect or click View on the Defect list window.

    3. The View Defect dialog box opens. All fields are read-only.

  3. Click the Workflow tab.

    4. This tab includes an overview of where the defect is in the workflow, what defect actions were assigned, who the actions were assigned to, and any comments or additional information a user entered.

  4. Click the History tab.

    5. Each time a defect action is assigned, TestTrack Pro adds this information to the defect’s history. The History tab includes who created the defect, when the defect was created, the creation method, who last modified the defect, and the date of the last modification.

  5. Click OK to close the View Defect dialog box.


Viewing attached files

You can view text files and bitmap files without extracting the files.

  1. Select the defect with the attached file you want to view.
  2. Choose Edit > Edit Defect.
  3. On the Detail tab, click the Attachments mini tab.
  4. Select the attached file and click View.

    5. The text file or graphics file is displayed.


Editing defects

  1. Select the defect on the Defects list window.
  2. Choose Edit > Edit Defect or click Edit on the Defects list window.

    3. The Edit Defect dialog box opens.

    If another user is editing a defect you open, a read-only icon opens next to the OK button. Click the icon to see who is editing the record. When the user finishes, the icon closes and the record is updated.

    Note: TestTrack Pro checks the database every 10 seconds for changes. Read-only records become available as soon as users finishes editing the records.
  3. Make any changes and click OK.

    4. Your changes are saved.


Opening attached files

Open saves a copy of an attached file and opens it with the application used to create it. For example, if a customer sends a Microsoft Word document, TestTrack Pro can open the file in Word.

  1. Select the defect you want to extract an attached file from.
  2. Choose Edit > Edit Defect.
  3. On the Detail tab, click the Attachments mini tab.
  4. Select the attached file and click Open.

    5. The Save and Open Extracted File As dialog box opens.

  5. Select the file location and enter a file name.
  6. Click Save.

    7. The file is extracted and opened.


Extracting attached files

Extract saves a copy of an attachment. For example, if a customer attaches a corrupted data file to a defect, you can extract the file to a specific folder.

  1. Select the defect you want to extract an attached file from.
  2. Choose Edit > Edit Defect.
  3. On the Detail tab, click the Attachments mini tab.
  4. Select the attached file and click Extract.

    5. The Save Extracted File As dialog box opens.

  5. Select the file location, enter a file name, and click Save.

    6. The file is extracted to the folder you selected. You can now open the file.


Duplicating defects

Note: Depending on your security level, you may not have access to this command.

If you are adding defects with the same basic information, you can save time by duplicating and editing a defect.

  1. Select the defect on the Defects list window.
  2. Choose Edit > Duplicate Defects.

    3. TestTrack Pro duplicates the defect and assigns a new defect number. The duplicated defect is added to the Defects list window.

  3. Edit the defect and save your changes.


Merging defects

Merging defects helps avoid confusion and keep your database organized. For example, two defects report the same issue. JoeDeveloper is assigned one defect and JaneDeveloper is assigned the other one. The developers are working on the same issue and do not realize it.

  1. Select the defects on the Defects list window.

    2. To select a range of defects, click the first defect in the range, then Shift+click the last defect. To select multiple defects not in a range, Ctrl+click each defect.

  2. Choose Edit > Merge Defects.

    3. A warning message opens, letting you know the defects will be merged and deleted from the database.

  3. Click OK.

    4. The defects are merged.

    • The resulting defect assumes the lowest defect number and the type, priority, and severity of that defect. All defect information is retained as multiple defect records. For example, if you merge three defects, the Detail tab shows three defect records. Each defect record includes the original defect information.
    • If one or more fields conflict, you are prompted to view the merged defect.


Editing additional defect reports

  1. Select the defect with the record you want to edit on the Defects list window.

    2. If you are on the Edit Defect dialog box, skip to step 3.

  2. Choose Edit > Edit Defect or click Edit on the Defects list window.

    3. The Edit Defect dialog box opens.

  3. Click the Detail tab and select the report you want to edit.
  4. Make any changes and click OK.


Deferring defect numbering

Note: You may not have access to this administrator command.

Deferred defect numbering lets you store new defects in the database and number them after confirming they are unique defects. When deferred defect numbering is active, new defects have a dash instead of a defect number. You should periodically review unnumbered, or deferred, defects and assign defect numbers, merge them with existing defects, or delete them.

  1. Select Edit > Options > Database Options.

    2. The Database Options dialog box opens.

  2. Click the Defects tab and select the deferred numbering options.


Assigning defect numbers

  1. Select the unnumbered defect on the Defects list window.
  2. Choose Activities > Defect Actions > Assign Defect Numbers.

    3. The defect is assigned the next defect number.


Renumbering defects

Note: You may not have access to this administrator command.

Over the duration of your project, you may delete or merge defects that leave gaps in the defect numbers sequence. Or, at the start of a new development cycle, you may want to purge all closed defects from the project and use it as a fresh starting point for testing. In both cases, you will need to renumber defects.

  1. Select the defect you want to renumber and choose Activities > Defect Actions > Renumber Defect.

    2. The Renumber Defects dialog box opens. The starting number is set to the next available defect number.

  2. Enter an unused defect number and click OK.

    3. The Renumber Defects dialog closes and the defect is renumbered.

    • If the renumbered defect number is higher than the next available defect number, the next available defect number is set to one higher than the renumbered defect. For example, if you renumber a defect to 1200, the next defect added will be 1201.
    • If you renumber the entire defect list, you still need to set the next available defect number to one greater than the highest defect number.


Changing bulk fields

Admin: The following security options must be enabled to access this command: Edit Defect, Edit Database Options, and Import from XML.

You can quickly, and easily, update multiple records in the TestTrack Pro database. Use this command to replace values for specific fields, search for and replace strings in text fields, or add text.

You can replace values for the following field types: General, Reported By, Steps to Reproduce, Computer Config, Defect Actions, and Custom Fields. For example, you can change the disposition for 100 records to on hold. Or you can change the Found by User for specific records.


Replacing general field values

  1. Select the defects on the Defects list window.
  2. Choose Activities > Bulk Field Changes.

    3. The Bulk Field Changes dialog box opens with the General tab selected.

  3. Make any changes.
    • To add text, enter the text in the Summary field and select Prepend or Append.
    • To replace text, enter the string you want to search for in the Replace field and the string you want to replace it with in the With field.
    • To change values, select the value from the corresponding list.
  4. Click OK.

    5. You are prompted to confirm the changes.

  5. Click OK.

    6. The records are updated.


Replacing reported by field values

  1. Select the defects on the Defects list window.
  2. Choose Activities > Bulk Field Changes.

    3. The Bulk Field Changes dialog box opens.

  3. Click the Reported By tab.
  4. Make any changes.
    • If defects are reported multiple times and you want to change all reported by records, select Apply changes to all Reported by records. If you only want to change the first reported by record, do not select this option. For example, you want to change the Found by user for 50 defects. Some of the defects were reported multiple times. Select this option to change the found by user for each reported by record. If you do not select this option, only the first reported by record is changed.
    • To change values, select the value from the corresponding list.
    • To add text, enter the text in the Description field and select Prepend or Append.
    • To replace Description text, enter the string you want to search for in the Replace field and the string you want to replace it with in the With field.
  5. Click OK.

    6. You are prompted to confirm the changes.

  6. Click OK.

    7. The records are updated.


Replacing steps to reproduce field values

  1. Select the defects on the Defects list window.
  2. Choose Activities > Bulk Field Changes.

    3. The Bulk Field Changes dialog box opens.

  3. Click the Steps to Reproduce tab.
  4. Make any changes.
    • If defects are reported multiple times and you want to change all reported by records, select Apply changes to all Reported by records. If you only want to change the first reported by record, do not select this option.
    • To change values, select the value from the corresponding list.
    • To add text, enter the text in the Steps to Reproduce field and select Prepend or Append.
    • To replace Steps to Reproduce text, enter the string you want to search for in the Replace field and the string you want to replace it with in the With field.
  5. Click OK.

    6. You are prompted to confirm the changes.

  6. Click OK.

    7. The records are updated.


Replacing computer config field values

  1. Select the defects on the Defects list window.
  2. Choose Activities > Bulk Field Changes.

    3. The Bulk Field Changes dialog box opens.

  3. Click the Computer Config tab.
  4. Make any changes.
    • If defects are reported multiple times and you want to change all reported by records, select Apply changes to all Reported by records. If you only want to change the first reported by record, do not select this option.
    • To change values, select the value from the corresponding list.
    • To add text, enter the text in the Other Hardware and Software field and select Prepend or Append.
    • To replace Other Hardware and Software text, enter the string you want to search for in the Replace field and the string you want to replace it with in the With field.
  5. Click OK.

    6. You are prompted to confirm the changes.

  6. Click OK.

    7. The records are updated.


Replacing defect actions field values

  1. Select the defects on the Defects list window.
  2. Choose Activities > Bulk Field Changes.

    3. The Bulk Field Changes dialog box opens.

  3. Click the Defect Actions tab.
  4. Select a Defect Action.

    5. The fields on this tab change based on the defect action you select.

  5. Make any changes.
    • To change all defect actions select Apply to all actions. Do not select this option if you only want to change the newest defect action. For example, you want to change Assign By user for 100 defects. Most of these defects were manually assigned multiple times. Select this option to change each assign by record for all defects. If you do not select this option, only the newest assign by record is changed.
    • To change values, select the value from the corresponding list.
    • To add text, enter the text in the Notes field and select Prepend or Append.
    • To replace Notes text, enter the string you want to search for in the Replace field and the string you want to replace it with in the With field.
  6. Click OK.

    7. You are prompted to confirm the changes.

  7. Click OK.

    8. The records are updated.


Replacing custom field values

  1. Select the defects on the Defects list window.
  2. Choose Activities > Bulk Field Changes.

    3. The Bulk Field Changes dialog box opens.

  3. Click the Custom Fields tab.
  4. Select a Custom Field.

    5. The fields on this tab change based on the custom field you select.

  5. Make any changes.
  6. Click OK.

    7. You are prompted to confirm the changes.

  7. Click OK.

    8. The records are updated.


Deleting additional defect reports

  1. Edit the defect you want to add an additional report to.
  2. Choose Activities > Delete Reported By.

    3. You can also click Remove on the Detail tab.

    The additional report is deleted.


Deleting attached files

  1. Select the defect you want to delete an attached file from.

    2. Make sure you want to permanently delete the attached file. You are not prompted to confirm the deletion and the action cannot be undone.

  2. Choose Edit > Edit Defect.
  3. On the Detail tab, click the Attachments mini tab.
  4. Select the file you want to delete and click Remove.

    5. The attached file is deleted.


Deleting defects

  1. Select the defect on the Defects list window.

    2. You can select more than one defect to delete.

  2. Choose Edit > Delete Defect or click Delete on the Defects list window.

    3. You are prompted to confirm the deletion.

  3. Click OK.


Managing the Workflow

Jump into the workflow…

...and track your defects from beginning to end!


About the workflow

The workflow consists of states, events, and transitions that define the path a defect takes from initial reporting to resolution. To move a defect from state to state, the defect is assigned to users who perform the action assigned to them. The status field, on the Edit Defect dialog box, corresponds to the defect state. The status field changes based on the defect action. For example, the status field changes to Fixed when a defect moves to the Fixed state.

TestTrack Pro’s workflow can be used “out of the box” to track defects and other issues such as change requests. It can also be customized to follow your company’s business processes. Workflows can include custom events and actions that support your company’s business processes.

Note: The TestTrack Pro administrator is generally responsible for configuring the workflow. See Customizing the Workflow for information.


About the default workflow

The information in this section is specific to the default workflow. The default workflow, which can be used out of the box, includes the following events:

  • Assign
  • Estimate
  • Fix
  • Verify
  • Force Close
  • Reopen
  • Release Notes
  • Comments

The steps you follow, and the defect actions you use, can differ depending on your company’s workflow.


Defect workflow example

The following graphic shows a more complex workflow process:


Understanding defect assignments and actions

Accountability, such as who is responsible for estimating, fixing, or verifying a fix, is an important component of defect tracking. Defects, and defect actions, are assigned to users to ensure someone is accountable and to move the defect through the workflow states. Depending on your security level and the database configuration, you may not have access to all, or some, of the defect actions.

Each company uses defect assignments and actions differently. One company might let all users assign defects. Another company might only want team leads to be responsible for assigning defects while the users are responsible for such things as estimating a fix, fixing a defect, or verifying the fix.

Did you know? Following is an example of how defect actions move a defect through the lifecycle:

The Lead Engineer is notified when a defect is added to the database. After reviewing the defect, the Lead Engineer assigns the defect to Joe Estimator. The next day, Joe Estimator is notified of the defect assignment in two ways: the Assigned defect indicator appears next to the defect on the Defects list window and he receives an email notification. Joe Estimator opens the defect and views the Workflow tab. He can view who assigned the defect and what action he needs to perform. He decides what needs to be done to fix the defect and enters the estimate information.

The Lead Engineer is notified that the defect changed. She reviews Joe Estimator’s work and assigns the fix to Jane User. When Jane User logs in, she is notified of the defect assignment. Jane User opens the defect and views the Workflow tab. She can view her current defect assignment information and also view Joe Estimator’s notes – this helps her begin working on the fix. When Jane User finishes entering the Fix Defect information, the Lead Engineer is notified that the defect changed. The Lead Engineer reviews Jane User’s fix and assigns the next defect action. This process continues until the defect is fixed, tested, verified, and closed.


Defect action toolbar

Each defect action has a corresponding button located in a toolbar. You can also access defect action commands from the Activities menu.

Icon | Action | Description
 | Assign | Assign the defect to a user
 | Estimate | Estimate the time needed to fix a defect or implement a new feature
 | Fix | Describe the fix
 | Verify | Verify the defect fix
 | Force close | Close the defect
 | Re-open | Re-open a closed defect
 | Release Notes | Add release notes to a defect
 | Comments | Add comments to the defect

Note: Custom icons can be added to the defect action toolbar. See Adding events for more information.


Assigning defects

  1. Choose Activities > Assign or click the Assign Defect toolbar button.

    2. The Assign dialog box opens.

  2. Select an Assign by user.

    3. This field defaults to the logged in user.

  3. Select an Assign to user.
  4. The Date defaults to the current date.

    5. You can enter another date or click the calendar to select a date.

  5. Enter any Notes about the defect you are assigning or any additional information.
  6. Click OK.
    7. Did you know? When you are assigned a defect, open the defect (Edit/View Defect dialog box) and click the Workflow tab. You can review the assignment notes. The person who assigned you the defect should let you know what defect action you are responsible for and provide any detailed information. If you need more information about the defect, select Mail > Reply to Submitter. The Send Mail dialog box opens. Enter your question and click Send.


Estimating fix time

  1. Choose Activities > Estimate or click the Estimate Fix toolbar button.

    2. The Estimate Problem dialog box opens.

  2. Select an Estimate by user.

    3. This field defaults to the logged in user.

  3. The Date defaults to the current date.

    4. You can enter another date or click the calendar to select a date.

  4. Enter the Estimated effort in hours to complete the fix.
  5. Enter any Notes about the estimate.
  6. Select a Version number.

    7. You may also be able to enter a version number.

  7. Enter an estimated Completion Date.

    8. You can also click the calendar to select a date.

  8. Click OK.

    9. You can also click Save & Assign to save the defect action and assign the defect to a user.


Fixing defects

  1. Choose Activities > Fix or click the Describe Fix toolbar button.

    2. The Fix dialog box opens.

  2. Select a Fixed By user.

    3. This field defaults to the current user.

  3. The Date defaults to the current date.

    4. You can enter another date or click the calendar to select a date.

  4. Optionally select a Resulting State.
    5. Note: You can only select a state if the workflow allows multiple resulting states.
  5. Enter the fix Effort.
  6. Enter any Notes about the fix.
  7. Select the Affects Documentation check box or the Affects Test Plan check box if either applies.
  8. Select a fix Resolution.
  9. Select the Version number.

    10. You may also be able to enter a version number.

  10. Click OK.


Verifying a fix

Note: A defect must be fixed before it can be verified.
  1. Choose Activities > Verify or click the Verify Fix toolbar button.

    2. The Verify dialog box opens.

  2. Select a Verify By user.

    3. This field defaults to the logged in user.

  3. The Date defaults to the current date.

    4. You can enter another date or click the calendar to select a date.

  4. Optionally select a Resulting State.
    5. Note: You can only select a state if the workflow allows multiple resulting states.
  5. Enter any Notes about the verification.

    6. If a fix fails, record why the fix failed. It can help with future planning.

  6. Select the Version number.

    7. You may also be able to enter a version number.

  7. Click OK.


Closing defects

The resolution of some defects does not follow the standard fix/verify model. For example, a defect might not actually be a bug. In this situation, you can close the defect immediately.

  1. Choose Activities > Force Close or click the Force Close Defect toolbar button.

    2. The Force Close dialog box opens.

  2. Select a Force Close By user.

    3. This field defaults to the logged in user.

  3. The Date defaults to the current date.

    4. You can enter another date or click the calendar to select a date.

  4. Enter any Notes about why the defect was closed.
  5. Select a Resolution.
  6. Click OK.


Re-opening defects

Occasionally, a closed or verified defect resurfaces. To return the defect to the Open state and restart its lifecycle, you need to re-open the defect.

  1. Choose Activities > Re-open or click the Re-open Defect toolbar button.

    2. The Re-Open dialog box opens.

  2. Select a Re-Open By user.

    3. This field defaults to the logged in user.

  3. The Date defaults to the current date.

    4. You can enter another date or click the calendar to select a date.

  4. Enter any Notes about why the defect was re-opened.
  5. Click OK.


Adding release notes to a defect

Note: You can add multiple release notes to a defect.
  1. Choose Activities > Release Notes or click the Release Notes toolbar button.

    2. The Release Notes dialog box opens.

  2. Select a Release Notes By user.

    3. This field defaults to the logged in user.

  3. The Date defaults to the current date.

    4. You can enter another date or click the calendar to select a date.

  4. Enter the Release Version.
  5. Enter the release notes.

    6. The notes are recorded with the defect history.

  6. Click OK.
    7. Did you know? Generating release notes is a two-step process. After you add release notes to a defect, you need to generate the release notes file. You can insert this file in your Read-me file or use it to create a separate Release Notes guide. For more information, see Creating release notes.


Creating release notes

Note: To generate release notes for just a few defects, select those defects on the Defects list window. If you do not know which defects contain release notes, add a column to the Defects list window to display the Has Release Notes? field.
  1. Choose Activities > Create Release Notes.

    2. The Create Release Notes dialog box opens.

  2. Enter the From version and the Through version you want to include in the release notes.

    3. If the release notes are specific to one version, enter the same version number in both fields.

  3. Select a filter from the Use Filter list to generate release notes for defects that meet the filter criteria.
  4. Select a product from the Limit to Product list to generate release notes for a specific product.
  5. Enter a character in the Begin each release note with field if you want each release note to start with the specific character (e.g., a bullet). You can also enter ASCII characters or leave the field empty.
  6. Click Preview.

    7. The Release Notes preview dialog opens. If you need to make changes, you can edit the release notes in the preview window.

  7. Click Create and Save to save the release notes.

    8. The Save Release Notes As dialog box opens.

  8. Select the directory where you want to save the release notes and enter a file name. Click Save.

    9. TestTrack Pro generates the release notes and saves the text file in the specified directory.


Adding comments

You can add comments to a defect to point something out to other users, clarify an issue, or just as a reminder. Other users can view your comments on the Workflow tab.

  1. Choose Activities > Comment or click the Add Comments toolbar button.

    2. The Comments dialog box opens.

  2. Select a Comment By user.

    3. This field defaults to the current user.

  3. The Date defaults to the current date.

    4. You can enter another date or click the calendar to select a date.

  4. Enter the comments.

    5. The comments are recorded with the defect history.

  5. Click OK.
    6. Note: To view defect comments, select the defect, click View or Edit, and then click the Workflow tab. All comments are included on the Workflow tab.


Viewing defect actions

You can view the defect action details.

  1. Select the defect on the Defects list window.
  2. Choose Edit > Defect or click Edit on the Defects list window.

    3. The Edit Defect dialog box opens.

  3. Click the Workflow tab.

    4. This tab includes a list of all the defect actions.

  4. Select the defect action you want to view.
  5. Choose Edit > View Action.

    6. A read-only dialog box for the defect action you chose opens. For example, the Verify Defect dialog box opens if you view a Verified action.

  6. Click OK to close the dialog.


Editing defect actions

You can edit defect actions to add more information or correct mistakes. For example, a defect resolution affects documentation, but you forgot to select the Affects Documentation check box. You can edit the action to select the check box.

  1. Select the defect on the Defects list window.
  2. Choose Edit > Defect or click Edit on the Defects list window.

    3. The Edit Defect dialog box opens.

  3. Click the Workflow tab.

    4. This tab includes a list of all the defect actions.

  4. Select the defect action you want to edit.
  5. Choose Edit > Edit Action.

    6. A dialog box for the defect action you chose opens.

  6. Make any changes and click OK.


Deleting defect actions

  1. Select the defect on the Defects list window.
  2. Choose Edit > Defect or click Edit on the Defects list window.

    3. The Edit Defect dialog box opens.

  3. Click the Workflow tab.

    4. This tab includes a list of all the defect actions.

  4. Select the defect action you want to delete.
  5. Choose Edit > Delete Action.

    6. You are prompted to confirm the deletion.

  6. Click OK.

    7. The defect action is deleted.


Replying to a defect submitter

If you need more information or have questions, you can send an email directly to the defect’s submitter.

  1. Select the defect on the Defects list window.
  2. Choose Mail > Reply to Submitter.

    3. The Reply to Submitter dialog box opens.

    • The To field is populated with the name of the user or customer who submitted the defect. You can also click Add to select additional users.
    • The Subject field contains the defect’s summary text.
    • The message body contains the defect description.
  3. Enter your question or the information you need to clarify.
  4. Click Send.

    5. The email is sent.


Sending mail from TestTrack Pro

You can send email directly from TestTrack Pro. This lets you easily communicate with other users and customers, without switching to your email program.

  1. Choose Mail > Send Mail.

    2. The Send Mail dialog box opens.

  2. Click Add.

    3. The Add Mail Recipients dialog box opens. All available users and customers are listed.

  3. Highlight the users/customers you want to send mail to and click Add.
  4. Enter a subject and message.
  5. Click Send.

    6. The email is sent.


Using Filters

Filter Out the Noise!

TestTrack Pro includes extensive filtering capabilities. You can use filters to sort defect records and list only those defects that meet the criteria you select. You can create a simple filter, for example a filter that only shows fixed defects.


Creating filters

If your database has a large number of defects, or you only need to work with certain types of defects, create a filter and use it to keep your defects list short and manageable.

Did you know? Create custom filters to quickly view defect lists. For example, you can create a filter to track bugs by priority or a filter to track opens bugs that need to be fixed by a specific release, etc.
  1. Choose Create > Filter or click Add on the Filters list window.

    2. The Add Defect Filter dialog box opens.

  2. Enter a Name and Description.
  3. Select a Share option.

    4. The default is private. If you share the filter, other users can edit the filter.

  4. Click Add to add a filter restriction.

    5. See Adding restrictions for more information.

  5. Select NOT/AND/OR operators and parentheses to build the Boolean Logic for the filter (optional step).

    6. The Boolean search criteria appear in the Selected Restrictions box at the bottom of the dialog box. For more information, see About Boolean searches.

  6. Click Validate.
    • If the filter criteria is valid, click OK.
    • If the filter criteria is not valid, an error message opens. Click OK to return to the Defect Filter dialog box and correct the error.
    • Click Clear to clear all restrictions and start over.
  7. Click Add.

    8. The Add Defect Filter dialog box clears and you can add another filter. Click Close when you finish adding filters.


Adding restrictions

  1. Click Add on the Add Defect Filter or Edit Defect Filter dialog.

    2. The Restriction dialog box opens.

  2. Select the field you want to include in the filter from the Restrict by list.
    3. Tip: Most defect actions include Notes fields. You can select the All Action Notes field from the Restrict by list to search these fields. After selecting All Action Notes, select an option, and enter the search text.
  3. Select the restriction options.

    4. The restrictions you can set changed based on the Restrict by field.

    • When selecting restrictions options, <Unknown> represents an empty field. For example, if you select <Unknown> with Restrict by set to Assigned To, it is interpreted as “Show all defects not assigned to anyone.”
    • If you are creating or editing restrictions with fields that include a text value, you can leave the text value empty. When the filter is applied, TestTrack Pro searches for the Restrict by field with an empty text value. This is useful if you are cleaning up your defect records and want to make sure that every defect includes a summary. Select Restrict by: Summary and leave the text value empty. When you apply the filter, all defects with an empty Summary field are listed.
  4. Click OK to save the restriction.

    5. You return to the Add Defect Filter dialog box.

    Note: Repeat steps 1-4 to add additional restrictions to the filter.


Viewing restrictions

  1. Select the restriction on the Add Defect Filter, Edit Defect Filter, or View Defect Filter dialog.
  2. Click View.

    3. The selected restriction opens in the Restriction dialog box. All fields are read-only and cannot be edited.

  3. Click OK to close the Restriction dialog box.


Editing restrictions

  1. Select the restriction on the Add Defect Filter or Edit Defect Filter dialog.
  2. Click Edit.

    3. The Restriction dialog box opens.

  3. Make any changes and click OK.

    4. The changes are saved and you return to the Advanced Find Defects dialog box.


Inserting restrictions

If a filter contains a large number of restrictions, you can insert a restriction in a specific position.

  1. Select the restriction on the Add Defect Filter or Edit Defect Filter dialog.

    2. The new restriction is inserted above the selected restriction.

  2. Click Insert.

    3. The Restriction dialog box opens.

  3. Select the field you want to include in the restriction.
  4. Select any options and enter the restrictions for the field.
  5. Click OK.

    6. The restriction is added.


Deleting restrictions

Note: You are not prompted to confirm the deletion and the action cannot be undone.
  1. Select the restriction on the Add Defect Filter or Edit Defect Filter dialog.
  2. Click Delete.

    3. The restriction is deleted.


About Boolean searches

You can use Boolean logic to create complex and highly precise filters. Boolean logic uses three connecting operators (AND, OR, NOT) to narrow or broaden a search or to exclude a term from a search.

And is a narrowing term. When you use the “and” operator, the filter or search returns records that match all of the criteria you choose. For example, if you search for Component A AND Component B, TestTrack Pro only lists defects containing both components.

Or is a broadening term. When you use the “or” operator, the filter or search returns records that match any of the criteria you choose. For example, if you search for Component A OR Component B, TestTrack Pro lists defects in which either term is found.

Not is an excluding term. When you use the “not” operator, the filter or search returns records that do not contain any of the criteria you choose. For example, if you search for NOT Component A, TestTrack Pro lists all defects—except for those containing the term Component A.


Using filters

  1. Select the filter from the Filter list on the Defects list window.
  2. The filter is applied to the defects.
    • Defects that meet the filter criteria are listed on the Defects list window.
    • To return to a list of all defects, select Not Filtered from the Filter list.


Viewing filters

  1. Select the filter on the Filters list window.
  2. Choose Edit > View Filter or click View on the Filters list window.

    3. The View Defect Filter dialog box opens. All fields are read-only.

  3. Click OK when you are finished.


Editing filters

  1. Select the filter on the Filters list window.
  2. Choose Edit > Edit Filter or click Edit on the Filters list window.

    3. The Edit Defect Filter dialog box opens.

  3. Make any changes and click OK.

    4. Your changes are saved and you return to the Filters list window.


Duplicating filters

  1. Select the filter on the Filters list window.
  2. Choose Edit > Duplicate Filter.

    3. The filter is duplicated. A number is added to the end of the filter name. For example, if you duplicate Priority Filter 2 times, the duplicated filters are named Priority Filter 1and Priority Filter 2.

  3. Modify the duplicated filter and save your changes.


Deleting filters

  1. Select the filter on the Filters list window.

    2. You can select more than one filter to delete.

  2. Choose Edit > Delete Filter or click Delete on the Filters list window.

    3. You are prompted to confirm the deletion.

  3. Click OK.

    4. The filter is deleted.


Managing Test Configs

Track the nuts and bolts!

It is important to pay attention to the computers defects are found on. Is it a hardware problem or a display driver bug? Track your test configurations and identify the patterns.


About test configs

A test configuration refers to a specific computer used for testing and the hardware and software found on this computer. You should track all your systems to see if bugs are computer-specific. Tracking test configurations helps you identify patterns in defects that may be related to specific hardware configurations or software configurations. You can verify that your application functions the same, or in an appropriately similar manner, across all supported platforms or configurations.


Adding test configs

  1. Choose Create > Test Config or click Add on the Test Configs list window.

    2. The Add Test Config dialog box opens with the CPU tab selected.

  2. Enter a Name to uniquely identify the test config.
  3. Enter the information on the CPU tab.
    • Click Capture Config. TestTrack Pro can automatically fill in some of the fields (for example, Operating System).
    • Enter information in the other CPU fields. This information is optional but you should provide as much detail as possible.
  4. Click the Peripherals tab and enter the peripherals information.

    5. These fields are optional but you should enter as much information as possible.

  5. Click Add.

    6. The Test Config is added.


Viewing test configs

  1. Select the test config on the Test Configs list window.
  2. Choose Edit > View Test Config or click View on the Test Configs list window.

    3. The View Test Config dialog box opens. All fields are read-only.

  3. Click OK when you are finished.

    4. You return to the Test Configurations list window.


Editing test configs

  1. Select the test config on the Test Configs list window.
  2. Choose Edit > Edit Test Config or click Edit on the Test Configs list window.

    3. The Edit Test Config dialog box opens.

  3. Make any changes and click OK.


Duplicating test configs

  1. Select the test config on the Test Configs list window.
  2. Choose Edit > Duplicate Test Config.

    3. The test configuration is duplicated. A number, incremented by 1, is added to the end of the test config name. For example, if you select and duplicate Eng-cube, the duplicated test config is named Eng-cube1.

  3. Modify the duplicated test config and save your changes.


Deleting test configs

  1. Select the test config on the Test Configs list window.

    2. You can select more than one test config to delete.

  2. Choose Edit > Delete Test Config or click Delete on the Test Configs list window.

    3. You are prompted to confirm the deletion.

  3. Click OK.


Generating Reports

Analyze and Report!

You will be running reports in no time! TestTrack Pro makes reporting simple—point, click, print, and read. You can design and preview each report before printing. You can also share your report with other users or keep it private.


About reports

Reports are used to analyze the data collected in your database. You can use filters to build reports that focus on the data you need. You can also share your reports with others or keep them private. You can create the following four kinds of reports:

  • Detail reports include detailed information about defects, customers, users, user groups, or test configurations.
  • Distribution reports include the distribution of defects. You can choose options such as defects found by user, defect status by component, etc. You can add a chart to the report for additional impact. For example, you could build a distribution report that shows the number of fixed defects for each user.
  • List reports include summary information about defects, customers, users, user groups, or test configurations. You select the fields to include in the report.
  • Trend reports include defect events over time. For example, how many defects have been fixed this week? You can add a chart to the report for additional impact. Use this report to determine how well you are managing defects.


Using stylesheets

Stylesheets are templates you can use to quickly generate formatted reports. Several Extensible Style Language (XSL) stylesheets are installed with TestTrack Pro to help you easily create reports with predefined layout and design options. The stylesheets are available to all TestTrack Pro users with access to the database.

Customizing stylesheets

You can customize an existing XSL stylesheet or create your own and add it to the TestTrack Pro database. Stylesheets are generally located in the Program Files/TestTrack Pro/StyleSheets directory or the Program Files/ Seapine/ TestTrack Pro/ Stylesheets directory. Each report type has a corresponding folder in the Stylesheets directory.

  • To customize an existing stylesheet, open the corresponding report folder, select the stylesheet, and modify it using a third-party tool, such as Altova’s XML Spy.
  • To add a new stylesheet, use a third-party tool to create the stylesheet. Copy the completed stylesheet to the corresponding report folder.
  • To include an image with a stylesheet, copy the image to the Images folder in the TestTrack Pro directory. Add the following script to the stylesheet:

<img>
<xsl:attribute name=”src”>
<xsl:value-of select=”external:get-server-image(‘imagename.gif’)” />
</xsl:attribute>
</img>


Setting default stylesheets

You can select default stylesheets to use when printing from list windows.

  1. Choose Edit > Options > Local Options.

    2. The Local Options dialog box opens.

  2. Click the Stylesheets tab.
  3. Select a Report Type from the list.

    4. Each Report Type corresponds to a list window. For example, the Filter View Detail Report prints a detail report for all filters in the database.

  4. Select a Default Stylesheet for the selected report or click Browse to use a customized stylesheet.
  5. Click OK.


Refreshing stylesheet menus

The server periodically searches the database for new stylesheets and updates the stylesheet menu options. You can determine the frequency of this update by modifying your database options.

  1. Choose Edit > Options > Database Options.
  2. Click the Reports tab.
  3. Select how often the server looks for new stylesheets.
  4. Click OK.


Creating text file report templates

Note: The best way to customize a report to meet your requirements is to create a stylesheet. See Using stylesheets for more information.

You can create custom report templates using a text editor, TestTrack Pro field codes, and alphanumeric characters. You can even create a tab or comma-delimited document for use with other databases/tools.

  1. Using Notepad, or another text editor, create the text document using field codes for TestTrack Pro-specific information. You can use other alphanumeric characters.

    2. The report is formatted based on the text code layout. Field codes are replaced with the corresponding text. For example, you can set up the following report template:

%ASSD% - %ASST%
----------------------
%DESC%

This creates a report that includes the date the defect was most recently assigned, followed by a dash, followed by the user the defect is assigned to. The next line is a dashed line. On the next line is the defect description. This pattern repeats until all selected records are displayed.

Note: For a list and description of field codes, see .
  1. Save the document.

    2. You can now print a report based on the template you created.


Using text file report templates

  1. Choose File > Print.

    2. If you do not want to print every item in the list, select the items you do want to print. Make sure you select the Only Print Selected Items check box on the Print Options dialog box. If you apply a filter only the defects that pass the filter will be used as the basis of the ad hoc report.

  2. Select Create report file from template.
  3. Click Save.

    4. The Select Report Template dialog box opens.

    Note: Select Text Files or All Files from the Files of type list.
  4. Select the report template you want to use and click Open.

    5. The Save Report As dialog box opens.

  5. Select a directory and enter a filename.
  6. Click Save.

    7. The report is saved as a text file.


Creating detail reports

  1. Choose Create > Report > Detail.

    2. You can also click Add on the Reports list window and select Detail.

    The Add Detail Report dialog box opens.

  2. Enter a Name and Title.

    3. The title appears at the top of the report when it is viewed or printed.

  3. Select a Share option.

    4. If you share the report, users with the proper command-level security can edit the report. Select Private to protect your report.

  4. Select the Report On options.
    • Select the record type from the Report contains list.
    • If you select Customers, Users, User Groups, Customers, or Test Configs you can build a report on all, or selected, records.
  5. Click the Options tab.
    • Select a Stylesheet or click Browse to use a customized stylesheet.
    • Select a Filter if you are reporting on defects and only want to include filtered defects.
    • Select Print items on separate pages to insert page breaks between each item in the report. Internet Explorer is the only browser that supports page breaks.
  6. Click the Sorting tab.

    7. Select a Primary or Secondary sort column and set the column sort order.

  7. Click Add.

    8. The report is added.


Creating distribution reports

  1. Choose Create > Report > Distribution.

    2. You can also click Add on the Reports list window and select Distribution.

    The Add Distribution Report dialog box opens.

  2. Enter a Name and Title.

    3. The title appears at the top of the report when it is viewed or printed.

  3. Select a Share option.

    4. If you share the report, users with the proper command-level security can edit the report. Select Private to protect your report.

  4. Select the Report On options.
    • Select Defects <field> by User to build a report that includes action by user. For example, Defects Found by User.
    • Select Defects report by <field> to build a report that includes the number of defects based on the chosen category. For example, Defects reported by Status.
    • Select Defect status by <field> to build a report that includes the defect status based on the chosen category. For example, Defects status by Type.
    • Select Defect <field> By <field> to build a report that includes the defect status using two criteria. For example, Defect Type by Priority.
  5. Click the Options tab.
    • Select the report date parameters for your report using the Period and through lists.
    • Select a Stylesheet or click Browse to use a customized stylesheet.
    • Select a Filter if you are reporting on defects and only want to include filtered defects.
    • Select Include totals to include totals for the selected report items. If you select this option, you can add the totals to a chart using the Data to Graph list on the Graphing tab.
    • Enter a number in the Records per printed page field to insert page breaks between rows in the report.
  6. Click the Sorting tab.

    7. Select a Primary and Secondary sort column and set the column sort order.

  7. Click the Charting tab.

    8. This tab is used to add a chart to the report. For more information, see Charting report data.

  8. Click Add.

    9. The report is added.


Creating list reports

  1. Choose Create > Report > List.

    2. You can also click Add on the Reports list window and select List.

    The Add List Report dialog box opens.

  2. Enter a Name and Title.

    3. The title appears at the top of the report when it is viewed or printed.

  3. Select a Share option.

    4. If you share the report, users with the proper command-level security can edit the report. Select Private to protect your report.

  4. Select the Report On options.
    • Select the record type from the Report contains list.
    • Select the fields from the Available Fields list and click Add.
    • To change the field order, select a field from the Fields in Report list and click Up or Down.
  5. Click the Options tab.
    • Select a Stylesheet or click Browse to use a customized stylesheet.
    • Select a Filter if you are reporting on defects and only want to include filtered defects.
    • Enter a number in the Records per printed page field to include page breaks between detail rows.
  6. Click the Sorting tab.

    7. Select a Primary and Secondary sort column and set the column sort order.

  7. Click the Formatting tab.

    8. Field and table settings are defined by the default stylesheet. This tab lets you override the stylesheet settings for a list report. For example, you can change the report header font style, size, color, or alignment. Select Report Header from the list and use the field settings to make any changes.

  8. Click Add.

    9. The report is added.


Creating trend reports

  1. Choose Create > Report > Trend.

    2. You can also click Add on the Reports list window and select Trend.

    The Add Trend Report dialog box opens.

  2. Enter a Name and Title.

    3. The title appears at the top of the report when it is viewed or printed.

  3. Select a Share option.

    4. If you share the report, users with the proper command-level security can edit the report. Select Private to protect your report.

  4. Select the Report On options.
    • Select Defect status in period to report on the number of defects in each state (Open, Fixed, etc.) over the specified reporting period.
    • Select Defects <field> by <field> to report on the number of defects that are Open, Fixed, Closed, etc. by Type, Priority, or Resolution.
    • Select Defect open age in period to report on the number of defects open over the specified period.
    • Select Actual vs. Estimated hours to include the difference between the actual and estimated defect fix time.
  5. Click the Options tab.
    • Select the date parameters for the report using the Period, From, and through lists.
    • Select a Stylesheet or click Browse to use a customized stylesheet.
    • Select a Filter if you are reporting on defects and only want to include filtered defects.
    • Select Include totals to include totals for the selected report items. If you select this option, you can add the totals to a chart using the Data to Graph list on the Charting tab.
    • Enter a number in the Records per printed page field to insert page breaks between detail rows.
  6. Click the Charting tab.

    7. This tab is used to add charts to the report. For more information, see Charting report data.

  7. Click Add.

    8. The report is added.


Charting report data

You can add charts to distribution and trend reports. The available charts include pie, 3D pie, bar, 3D bar, area, 3D area, line, and 3D line.

Bar, area, and line charts

You can design a bar, area, or line chart using the available graphing fields.

Graphing field: | Use to:
Type | Select the type of report
Data to Chart | Select report data
Title | Enter a chart title
Size | Select the chart title size
Color | Select the chart title font color
Height | Select the chart height
Width | Select the chart width
Background Color | Select the chart background color
X Axis Title | Enter an X axis title
Y Axis Title | Enter a Y axis title
Size | Select the X and Y axis title size
Color | Select the X and Y axis title font colors
Show Labels | Show chart component labels
X Axis Size | Select the X axis label size
Y Axis Size | Select the Y axis label size
Spacing | Enter the amount of space between labels
Color | Select the X and Y axis label color
Density | Enter a density percentage. 80% displays all labels, 40% displays half, etc.
Show Grid | Select to show the chart grid pattern
Show X Axis | Select to show the X axis
Show Y Axis | Select to show the Y axis
Color | Select the color for the grid lines and the X and Y axis lines

Pie charts

Use the graphing fields to add and design pie charts.

Graphing field: | Use to:
Type | Select the report type
Data to Chart | Select report data
Title | Enter a chart title
Size | Select the chart title size
Color | Select the chart title font color
Height | Select the chart height
Width | Select the chart width
Background Color | Select the chart background color
Show Labels | Show chart data labels
Show Percents | Show chart data in percents
Label Size | Select the chart label size
Color | Select the label font colors
Label Position | Set the spacing of the chart labels

Did you know? Pie charts are scaled based on a number of factors, including image size, label size, and number of labels. You may need to change the image height and width dimensions for the pie chart to display correctly.


Viewing report settings

  1. Select the report on the Reports list window.
  2. Choose Edit > View Report or click View on the Reports list window.

    3. The View Report dialog box opens. All fields are read-only.

  3. Click OK when you are finished.


Editing reports

  1. Select the report on the Reports list window.
  2. Choose Edit > Edit Report or click Edit on the Reports list window.

    3. The Edit Report dialog box opens.

  3. Make any changes and click OK.


Previewing reports

  1. Select the report on the Reports list window and click Preview.

    2. The report opens in preview mode.

  2. Click the Next and Previous arrows, or use the scroll bar, to move through the report.
  3. Click Page Setup to change the page options or click Print to print the report.
    4. Note: You can also click Save As to save the report as a text file.


Printing reports

  1. Select the report on the Reports list window and click Print.

    2. The print dialog box opens.

  2. Make your selections and click Print.


Saving a copy of a report

You can save a copy of a report as an HTML file and open it later to modify the data.

  1. Select the report on the Reports list window and click Preview.
  2. Choose File > Save As.

    3. The Save Report Files dialog box opens.

  3. Select a Save in location.
  4. Enter a File name.
  5. HTML Files is automatically selected from the Save as type list.
  6. Click Save.

    7. The report file is saved in the location you specified.


Deleting reports

  1. Select the report on the Reports list window.

    2. You can select more than one report to delete.

  2. Choose Edit > Delete Report or click Delete on the Reports list window.

    3. You are prompted to confirm the deletion.

  3. Click OK.

    4. The report is deleted.


Using the Workbook

So much to do...

so little time to do it? Use the Workbook to view defects and track other tasks. TestTrack Pro, and the Workbook, can help you stay organized!


About the workbook

Use the Workbook to keep track of defects, loose ends, and various other tasks. For example, you can add To Do tasks to remind you about upcoming deadlines.


Understanding Workbook tasks

You can track defect tasks and To Do tasks in the Workbook. Task indicators in the type column of the Workbook list point out your assigned defects and the To Do tasks you added to the Workbook.

Icon | Name | Indicates
 | Defect tasks | Defects assigned to you. TestTrack Pro adds these tasks to the Workbook.
 | To Do tasks | Defects that changed since you last logged in


Adding to do tasks

  1. Choose Create > To Do or click Add on the Workbook list window.

    2. The Add To Do dialog box opens.

  2. Enter a task name in the To Do field.
  3. Select the task Priority.
  4. Check the date.
  5. Select a Need by date or Version.
  6. Enter a description.
  7. Click Add.

    8. The task is added to TestTrack Pro.


Viewing to do tasks

  1. Select the task or defect on the Workbook list window.
  2. Choose Edit > View Task or click View on the Workbook list window.

    3. The View To Do or View Defect dialog box opens. All fields are read-only.

  3. Click OK when you are finished.


Editing to do tasks

  1. Select the task or defect on the Workbook list window.
  2. Choose Edit > Edit Task or click Edit on the Workbook list window.

    3. The Edit To Do or Edit Defect dialog box opens.

  3. Make any changes.

    4. If the task is complete, select Done.

  4. Click OK.

    5. Your changes are saved and you return to the Workbook list window.


Duplicating to do tasks

  1. Select the task on the Workbook list window. You can only duplicate tasks, you cannot duplicate defects.
  2. Choose Edit > Duplicate Task.

    3. The task is duplicated.

  3. Modify the duplicated task and save your changes.


Deleting to do tasks

  1. Select the task on the Workbook list window. You can only delete tasks. You cannot delete defects.
  2. Choose Edit > Delete Task or click Delete on the Workbook list window.

    3. You are prompted to confirm the deletion.

  3. Click OK.

    4. The task is deleted.


Integrating SCC applications

Integrate TestTrack Pro...

with your Source Code Control (SCC) application! This integration lets you associate TestTrack Pro defects with your source code, enhancing your product quality.


Using source code control with TestTrack Pro

You can integrate the following SCC applications with TestTrack Pro: CS-RCS, CVS, ClearCase, PVCS, Perforce, SourceOffSite Classic, StarTeam, Surround SCM, and Visual SourceSafe. You must configure the integration before you can access your SCC application through TestTrack Pro. SCC integration includes the following commands: attach file, detach file, get, check in, check out, undo check out, view, and history.

Note: For more information about specific SCC applications and their integration with TestTrack Pro, see Configuring SCC Integration.


Configuring SCC integration

  1. Choose Configure > SCC Integration.

    2. The Configure SCC Integration dialog box opens with the Local Options tab selected. The Local Options tab lists the installed SCC providers.

    Note: CVS is always displayed in the Available Providers list. Do not set up CVS integration unless CVS is installed on your computer.
  2. Select the application you want to use from the Available Providers list and click Make Current.

    3. The application you selected is listed in the Current box. The Local Options tab is the only tab available until you select an SCC application.

    Tip: You probably use one source code control program. You must still select the application and click Make Current.
  3. Click the User Options tab.

    4. The user options settings are stored in the TestTrack Pro database for the currently logged in user. If you log in to multiple TestTrack Pro databases, SCC user options must be configured for each database.

  4. Click Browse to select the project database.

    5. If you use Visual SourceSafe or PVCS you must also enter a valid username and password.

  5. Click Validate Connection to test the connection parameters. If you receive an error message, correct the error and try again.


Disabling SCC integration

  1. Choose Configure > SCC Integration.

    2. The Configure SCC Integration dialog box opens.

  2. Select the provider you want to disable and click Disable SCC Integration.
  3. You are prompted to confirm that you want to disable the SCC integration.
  4. Click Yes to disable the integration.


General source code tab information

Did you know? How do I know if source files are attached to a defect?

Add a new column to the Defects list window and select Has SCC files? for the heading. Yes appears in the column if source files are attached to a defect.

The source code tab provides the following information about the source files attached to a defect.

Source Files | All files attached to the defect.
Fixed Revision | Each revision number where the file was checked in from the defect. Revision numbers are obtained from the SCC application. If the file is not checked in through TestTrack Pro, the revision number is not updated.
Fixed Timestamp | The timestamp of the latest fixed revision found in the Fixed revision column.
Locked By | The username is displayed if it can be determined. If the username cannot be determined, “current user” or “another user” is usually displayed.


Attaching files

This command is used to attach files to a defect. You should attach any file in SCC that is related to the defect. For example, you might attach a source file that changed while fixing the defect.

Did you know? You can attach a source code file when adding a defect, but you will probably attach files when editing defects. Generally, QA, support, or customers add defects. A developer, or other team member (such as a documentation team member), usually attache source code files to a defect after the bug is added.
  1. Select the defect you want to attach a file to on the Defects list window.
  2. Choose Edit >Edit defect or click Edit on the Defects list window.
  3. Click the Source Code tab.
  4. Click Attach File.

    5. The Attach File(s) dialog box opens.

  5. Select the project you want to work with from the SCC Projects list.

    6. A list of available files opens in the Files in project list.

    Note: The SCC application is not queried for data after the Attach File(s) dialog box opens for the first time. If you add files or directories to your SCC project, click Refresh. The TestTrack Pro client will call the PVCS or Perforce interface to obtain the list of files that are under source code control.
  6. Select the files you want to attach from the Files in project list and click the right arrow button (>>).

    7. The files are listed in the Files to attach list. If you make a mistake, select the file in the Files to attach list and click the left arrow button (<<).

  7. Click OK when you are finished.
    8. Did you know? If you are using ClearCase, PVCS, or Perforce, make sure you only attach relevant files. Due to the program interfaces, attaching files can cause a small delay in performance depending on the number of files in the database. This slow down is based on the number of attached files, not the number of files in ClearCase, PVCS, or Perforce.

    The first time you attach SCC files, the Attach File(s) dialog box may take a longer time than expected to open. The TestTrack Pro client must call the program to obtain a list of files that are under source code control. The next time you access the Attach function, it will be a faster process because the list of SCC files are cached by TestTrack Pro.


Detaching files

This command is used to detach files from a defect. When you detach files, it removes the association of the SCC file to the defect. This action does not make any changes in the SCC application.

  1. Select the defect you want to detach a file from on the Defects list window.
  2. Choose Edit >Edit defect or click Edit on the Defects list window.
  3. Click the Source Code tab.
  4. Select the source file and click Detach File.

    5. You are prompted to make sure you want to detach the selected file.

  5. Click Yes.

    6. The file is detached.


Getting files

This command is used to view, and not edit, a file. When you get a file, a read-only file is copied to the directory you specify.

Note: If you are using Perforce, the Get command syncs the local file with the depot file. If a file is checked out or locked, the Get command does not work.
  1. Select the defect you want to get SCC files from on the Defects list window.
  2. Choose Edit >Edit defect or click Edit on the Defects list window.
  3. Click the Source Code tab.
  4. Select the source file(s) and click Get.

    5. The Get File(s) dialog box opens.

  5. Enter a directory path or click Browse to select a path. You can leave the path field empty to use the default location.
    • If you are getting a single file, the value of the path field is determined by the SCC user configuration.
    • If you are getting multiple files, the path field may be empty since each file can have a different default location.
  6. Select Make writable if you want to be able to edit the file.
  7. Select Only show dialog when Shift key is down if you do not want the Get File(s) dialog box to open.

    8. If you select this option, the settings you entered are used each time you get a file. To display the dialog, hold down the Shift key before clicking Get.

  8. Click OK.

    9. The file is copied to the directory you specified.


Checking in files

This command updates the SCC application with the changes you made and unlocks the file. When another user accesses the file in the SCC application, the file includes all the modifications you made. If you check in files outside of TestTrack Pro, the fixed revision and fixed timestamp information is not captured in the TestTrack Pro database.

Note: If you are using Perforce, you can only check in files from the default changelist.
  1. Select the defect with the file you want to check in on the Defects list window.
  2. Choose Edit >Edit defect or click Edit on the Defects list window.
  3. Click the Source Code tab.
  4. Select the source file(s) and click Check in.

    5. The Check in File(s) dialog box opens.

  5. Check the path.

    6. This field defaults to the directory path you chose when the file was checked out. You can enter a different path or click Browse to select a path.

  6. Select Keep checked out to update the master copy of a file while keeping the file checked out.
  7. Select Remove local file to remove the copy from your working folder.
  8. Enter any comments.

    9. Your database may include a check in comments template that automatically populates the comments field. You can add comments to the field or delete the comments and add your own. Select Apply comments to all files to use the same comment for each source file. This only applies if you are checking in multiple files at the same time.

  9. Click Check in & Fix to check in the selected file(s) and then fix the defect(s).

    10. The files are checked in and the Fix Defect dialog box opens.

    Note: Check in & Fix is only available if the defect is in the Open state.
  10. Click Check in to check in the file(s) without fixing the defect.


Checking out files

This command lets you check out one or more files for editing. A writable copy of the file is placed in the directory you specify. Any user can attempt to check out a file in TestTrack Pro. If the SCC application is not configured to allow multiple checkouts, or a user has exclusively locked the file, the user trying to check out the file will be notified of the check out failure.

  1. Select the defect you want to check out a file from on the Defects list window.
  2. Choose Edit >Edit defect or click Edit on the Defects list window.
  3. Click the Source Code tab.
  4. Select the source file(s) and click Check out.

    5. The Check Out File(s) dialog box opens.

  5. Enter a description of the reason for the check out in the Comment field.

    6. Perforce does not support the Comment field.

  6. Enter a directory path or click Browse to select a path.

    7. If you leave the Path field empty, the default location is used. The default location is determined by the SCC application, based on the SCC user configuration.

    If you are checking out a single file, the value of the path field is determined by the SCC user configuration. If you are checking out multiple files, the path field may be empty because the default location can differ for each file.

  7. Select a Replace writable option.

    8. This option determines what happens if you try to check out a file that is already marked as writable.

    • Ask prompts you to confirm that you want to overwrite the file.
    • Replace automatically overwrites the writable file.
    • Skip ignores the check out operation for the writable file.
  8. Select a Set file time option.
    • Current sets the current time (time of check out).
    • Check in sets the time to the check in time.
    • Modified sets the time to the last modification time.
      • Note: This option is not available if you are using StarTeam.
  9. Click OK.

    10. The file(s) is checked out.


Undoing check out

This command undoes a check out operation.

  1. On the Source Code tab, select the source file and click Undo Check out.

    2. The Undo Check out dialog box opens.

  2. Select a Local file option.
    • Replace the file in your local directory.
    • Leave the file in your local directory.
    • Delete the file from your working folder.
  3. Click OK.


Viewing files

This command displays a copy of the selected file.

  1. On the Source Code tab, select the source file and click View.

    2. The View File dialog box opens.

  2. Select a Viewing option and click OK.

    3. A copy of the file is opened.


Viewing file history

This command displays a file’s history.

  1. On the Source Code tab, select the source file and click History.

    2. The File History dialog box opens.

  2. Click Close when you are finished.


Integrating with Development Tools

Use the TestTrack Pro Add-In…

and never leave your development environment! Use the add-in to access TestTrack Pro functions, from within Visual Basic, Visual C++, and Visual Studio .NET.


About the TestTrack Pro Add-In

The TestTrack Pro Add-In can be used with Visual Basic 6.0, Visual C++ 6.0, and Visual Studio .NET. The Add-In lets you stay in your development environment while accessing TestTrack Pro functions. A dockable TestTrack Pro toolbar is added to the IDE.

The TestTrack Pro Add-In functions the same regardless of your development environment. There are a few exceptions:

  • Visual Basic has no concept of a workspace. If you are working in the Visual Basic development environment, there is no provision for connecting to a database. Also, you cannot set TestTrack Pro Add-In options in Visual Basic.
  • Visual C++ refers to workspaces. Visual Studio .NET refers to solutions.


Installing the Add-In

During TestTrack Pro client installation, the Add-In Options dialog box opens if Visual Basic 6.0, Visual C++6.0, or Visual Studio .NET are installed on your computer. The TestTrack Pro Add-In is automatically installed.

  • If Visual C++ 6.0 is installed on your computer, make sure you read the Note information. It include instructions for enabling the Add-In.
  • If Visual Basic 6.0 or Visual Studio .NET is installed on your computer, select the corresponding development environment check box. You do not need to manually enable the Add-In.


Add-In toolbar

The TestTrack Pro toolbar contains buttons that give you access to TestTrack Pro functions and list windows—just a click away!

Button | Name | Action
 | Connect | Connects you to the server
 | Disconnect | Disconnects your server connection
 | Defect List | Opens the Defects list window
 | Add Defect | Opens the Add Defect dialog box
 | Task List | Opens the Workbook/Task list window
 | Add Task | Opens the Add To Do dialog box
 | Options | Opens the Options dialog box
 | About | Opens the About dialog box

Note: The Options button is not available with Visual Basic.


Connecting to a database

  1. Click the Connect toolbar button.

    2. The Server Connection dialog box opens.

  2. Select a server from the Connect to TestTrack Pro Server menu and click Connect.

    3. The Login dialog box opens.

  3. Enter your username and password.
  4. Select a database from the Database menu and click OK.

    5. You are connected to the TestTrack Pro server and database.

    Did you know? Where to go next...

    If you are the Lead Engineer, start with the Defects list. Use a filter to display all defects created, fixed, or verified in the last week and that are not currently assigned and not in the closed state. Then, assign the defects to the appropriate person.

    If you are an Engineer/Developer, start with the Task list. The Workbook Task list displays all the defects assigned to you and any to do tasks you added. You can also start with the Defects list and choose a filter that displays the defects you need to work with.


Setting options

You can set Open Workspace and Login options that are specific to Visual C++ and Visual Studio .NET.

Note: Remember, Visual Studio .NET refers to solutions and Visual C++ refers to workspaces. The following examples and screenshots use Visual C++. If you are working in a Visual Studio .NET development environment, the dialog boxes and text may be different.

Each workspace/solution can be associated with a single TestTrack Pro database. Multiple workspaces/solutions can also be associated with one TestTrack Pro database. The TestTrack Pro database does not have a direct link to a workspace/solution.

When a workspace/solution is opened, and a TestTrack Pro database is associated with the workspace/solution, the TestTrack Pro Add-In receives a message. A connection with the TestTrack Pro server is established and you are logged into the database. When a workspace/solution is closed, you are logged out of the current database.

Open Workspace tab

  1. Click the Options toolbar button.

    2. The Developer Studio Add-In Options dialog box opens with the Open Workspace tab selected.

  2. Select Do nothing (leave the TestTrack connection as is) if you do not want to connect to the TestTrack Pro Server and log in to a TestTrack Pro database.
  3. Select Always login to the default TestTrack database to automatically log in to your default database. You can specify the default database on the Login tab.
  4. Select Login to the TestTrack database associated with this workspace to automatically log in to a database. After selecting this option, you need to choose an option from the dropdown list. The dropdown list determines what happens when a TestTrack Pro database is not associated with the workspace.

Setting default login information

The Login tab lets you set the default login information and associate Visual Studio workspaces with TestTrack Pro databases. When you open a workspace, you can automatically login and connect to a specific TestTrack Pro database.

  1. Click the Options toolbar button.

    2. The Developer Studio Add-In Options dialog box opens.

  2. Click the Login tab.
  3. Click Edit in the Default TestTrack Login area.
  4. The Associate Workspace with TestTrack dialog box opens.
  5. Select a server.

    6. Click Configure to add a server. For more information, see Setting up server connections.

  6. Select a database.
  7. Enter your Username and Password.
  8. Click OK.

    9. The Default TestTrack Login area is populated with the information you entered. Click Edit to change any information.

Associating a workspace with TestTrack Pro

  1. Click the Options toolbar button.

    2. The Developer Studio Add-In Options dialog box opens.

  2. Click the Login tab.
  3. click Add in the Associate TestTrack area.

    4. The Associate Workspace with TestTrack dialog box opens.

  4. Click Use Current or the Browse button to select the workspace you want to associate with the database.

    5. Selecting Save full pathname for the workspace gives you greater control of the workspace association. For example, you have two workspace files with the same filename. This option lets you associate each workspace with a different TestTrack Pro database.

  5. Select a server.

    6. Click Configure to add a server. For more information, see Setting up server connections.

  6. Select a database.
  7. Enter your Username and Password.
  8. Click OK.

    9. The Associate TestTrack area is populated with the information you entered.

    Note: Select a row and click Edit to make changes. If you want to delete an association, select a row and click Delete. Make sure you want to delete the association - you are not prompted to confirm the deletion and this action cannot be undone!


Working with defects

The defect list tracks all defects entered in a database. For more information, see About defects.

Opening the defect list

  1. Click the Defect List toolbar button.

    2. The Defects list window opens.

Adding defects

  1. Click the Add Defect toolbar button or click Add on the Defect list window.

    2. The Add Defect dialog box opens.

  2. Enter the defect information.

    3. For more information, see Adding defects.

  3. Click Add to save the defect information and add the defect.

    4. Click Close to close the Add Defect dialog box.

Viewing defects

  1. Select the defect on the Defects list window.
  2. Click View.

    3. The View Defect dialog box opens. All fields are read-only.

Editing defects

  1. Select the defect on the Defects list window.
  2. Click Edit.

    3. The Edit Defect dialog box opens.

  3. Make any changes and click OK.

Deleting defects

  1. Select the defect on the Defects list window.
  2. Click Delete.

    3. You are prompted to confirm the deletion.

  3. Click OK.


Using the workbook

The workbook tracks your defects, loose ends, and other tasks. For example, you can add tasks to remind you about meetings or upcoming deadlines.

Task indicators appear in the type column of the Workbook list window. These indicators point out your assigned defects and tasks you added.

Icon | Name | Indicates
 | Defect tasks | Defects assigned to you. TestTrack Pro adds these tasks to the workbook.
 | To Do tasks | Project-related tasks you add to the workbook.

Opening the Workbook task list

  1. Click the Task List toolbar button.

    2. The Workbook list window opens.

Adding tasks

  1. Click the Add Task toolbar button or click Add on the Workbook list window.

    2. The Add To Do dialog box opens.

  2. Enter the task information.

    3. For more information, see Adding to do tasks.

  3. Click Add.

    4. The dialog box clears and you can add another task. Click Close when you finish.

Editing tasks

  1. Select the task or defect on the Workbook list window.
  2. Click Edit.

    3. The Edit To Do or Edit Defect dialog box opens.

  3. Make any changes and click OK.

    4. If the To Do task is completed, select Done. The task appears greyed-out and a check mark is displayed in the first column of the Workbook list window.

Viewing tasks

  1. Select the task or defect on the Workbook list window.
  2. Click View.

    3. The View To Do or View Defect dialog box opens. All fields are read-only.

Deleting tasks

  1. Select the task on the Workbook list window.

    2. You can only delete To Do tasks. You cannot delete defects.

  2. Click Delete.

    3. You are prompted to confirm the deletion.

  3. Click OK.

    4. The To Do task is deleted.


Disconnecting

When you finish working with your defects, make sure you disconnect from the database and server.

  1. Click the Disconnect toolbar button.

    2. A warning message opens, stating the open database and server connection will be closed.

  2. Click Yes.

    3. The database is closed and you are disconnected from the server.


Configuring Databases

Lay the foundation!

Databases are one of the most important components of TestTrack Pro - take the time to configure your databases and keep your users productive!


About databases

A TestTrack Pro database contains all the information you track, including defects, user groups, users, customers, filters, test configurations, and workbook tasks.

Databases are initially created and stored on the computer where the TestTrack Pro Server is installed. Databases can be also be moved to another computer, separate from the computer where the TestTrack Pro Server is installed. For more information, see the Server Admin Utility Guide.

Creating databases

The TestTrack Pro administrator, or another user with high level security, creates all the databases using the Server Admin Utility. If you need a new database, see your administrator. If you are the TestTrack Pro administrator, see Creating a database in the Server Admin Utility Guide.


Setting general options

  1. Chose Edit > Options > Database Options.

    2. The Database Options dialog box opens, with the General tab selected.

  2. Enter a Project Name and Description.

    3. The project name does not change the database name.

  3. Select Hide navigation buttons if no security access to hide the Web navigation buttons.

    4. If you do not select this option, and the user does not have security access, the buttons appear on the web page but are disabled. This option only affects the web client.

  4. Select Replace graphics if field labels are renamed to automatically replace the corresponding field label graphics.

    5. Do not select this option if you use custom graphics for renamed fields.

  5. Select Show inactive states and events in reports, filters, list windows, etc. if you want inactive states and events to be included in the reports dialog, the filter dialog, the list window column pop-up menu, and reports.
  6. Click OK or click another tab to continue setting options.


Setting defect options

  1. Chose Edit > Options > Database Options.
  2. Click the Defects tab.
  3. Select the Defer numbering defects options.

    4. For each of the options, select the check box to automatically assign a defect number.

  4. Select the Next number options.
    • The Next defect number can be set to any value greater than the largest defect number.
    • The Next sequence number can be set to any value greater than the largest sequence number.
  5. Select the Version fields options. Version fields options affect the following fields: version found, version fixed, version verified, version released, and estimated completion.

    6. You can configure version field menus to accept text entries or restrict version fields to pop-up menus.

    Note: When sorting on version field, use advanced logic tells TestTrack Pro to look for delimiters and sort the alphanumeric characters in that section.
  6. Select Enable logging of historical defect information to log historical information.

    7. For more information, see Logging historical defect information.

  7. Click OK or click another tab to continue setting options.


Setting send mail options

  1. Chose Edit > Options > Database Options.
  2. Click the Send Mail tab.
  3. Select Enable sending of mail for this project to enable mail.

    4. If you do not select this option, users cannot use the Send Mail command or receive email notifications.

  4. Select the Return address options.
    • Always use the notification email account for the return address is the default option.
    • Only use notification account if no TestTrack user is logged in uses the notification account information. For example, a user might not be logged in during email import or while using SoloSubmit. In either case, the notification account information is used.
    • Only use notification account if the logged in user’s email address is blank ensures that an email address is available if the logged in user did not provide an email address.
    • Enter a notification account name. The notification account name defaults to “TestTrack.” You will probably want to customize the account name for your company
    • Enter an email address. If you do not enter an email address, your email may be rejected. Some Internet providers will not accept email without a return address.
  5. Select the Closing defects options. These options send notifications for closed defects.
    • Select Send mail to defect’s submitters if defect moves to a “Closed” state to notify the submitters of the change. Select a submitter option from the dropdown list. If a defect is submitted by more than one person, each person is sent an email.
    • Select Don’t send notification if defect is added in a closed state if you do not want a notification sent for defects added in a closed state. For example, you add a defect, enter defect information, add a fixed event, and add a verify & close event. You probably do not want to send a notification since the defect was added in the closed state.
    • Select an email template.
  6. Select a defect notification template.

    7. This template is used when notifications are sent to users or customers.

  7. Click OK or click another tab to continue setting options.


Setting field relationship options

These options force a child field’s value to <not set> if a parent field changes and the child field value is invalid.

  1. Chose Edit > Options > Database Options.
  2. Click the Relationships tab.
  3. Select On the Add Defect window, force the child field’s value to <not set> to enforce the field relationship and prevent data that does not make sense from being added.
  4. Select On the Edit Defect window, force the child field’s value to <not set> to enforce the field relationship and prevent data that does not make sense from being added.

    5. Do not select this option if historical defect information is important and you want to preserve the original defect information.

    Did you know? Text entries in version fields decrease the power of field relationships. If Version Found is a child field, and users can add text entries, the value cannot be forced to <not set> because field relationship rules cannot be enforced.
  5. Click OK or click another tab to continue setting options.


Setting import mail options

  1. Chose Edit > Options > Database Options.
  2. Click the Import Mail tab.
  3. Select Enable importing defects via email to enable email import.
  4. Enter the POP3 host IP address or domain name.

    5. Do not use a personal email address as the import mail account. TestTrack Pro imports everything, including personal email like jokes, into the database.

  5. Enter the Account Name and Password.

    6. Leave the password field empty if a password is not required.

    Did you know? Why does TestTrack Pro require a dedicated email address?

    All email from the specified account is imported. TestTrack Pro cannot determine which database an email should be imported into. In addition, TestTrack Pro cannot differentiate between personal and business emails.

    In addition, make sure the import email account is not the same as the return email account configured on the Send Mail tab. TestTrack Pro can get stuck in a loop if an email account uses an auto-reply and you configure TestTrack Pro to send an acknowledgment after importing mail.
  6. Select a Look for new files time interval.

    7. You can override the selected interval at any time. Choose File > Import > Perform Server Import.

  7. Select Email an acknowledgement to the submitter to automatically acknowledge the email.

    8. Select the email template you want to use.

  8. Select Enter next sequence number in defect’s reference field to automatically enter the next defect sequence number.
  9. Enter the Time to wait for initial connection response.

    10. This is the time the TestTrack Pro server waits for an initial response from the email server.

  10. Enter the Time to wait for other connection responses.

    11. This is the time the TestTrack Pro server waits for other connection responses from the email server.

  11. Click OK or click another tab to continue setting options.


Setting SoloBug options

  1. Chose Edit > Options > Database Options.
  2. Click the SoloBug tab.
  3. Select a Look for new files time interval.

    4. To manually import files, choose File > Import > Perform Server Import.

  4. Select an After importing option.
  5. Select Email an acknowledgement to the submitted to automatically send an acknowledgement.

    6. Select the email template you want to use.

  6. Select Enter next sequence number in defect’s reference field to automatically enter the next sequence number in the reference field.
  7. Click OK or click another tab to continue setting options.


Setting SoloSubmit options

Tip: The TestTrack Pro SoloSubmit Admin Guide includes detailed information about configuring and customizing SoloSubmit.
  1. Chose Edit > Options > Database Options.
  2. Click the SoloSubmit tab.
  3. Select Enable entering defects via the SoloSubmit web page to enable SoloSubmit.

    4. Remember, this option is database-specific. SoloSubmit must be enabled for each database.

  4. The SoloSubmit HTML page field defaults to solosubmit.htm.

    5. If you use a customized SoloSubmit HTML page, enter the file name. Make sure the HTML file is in the correct TestTrack Pro directory on your web server.

  5. Select Email an acknowledgement to the submitter to automatically send an email acknowledging the submission. This lets users and customers know their defect was received.

    6. Select the email template you want to use.

  6. Select Enter next sequence number in defect’s reference field to automatically enter the next defect sequence number.
  7. Select Enforce required field validation to ensure that values are entered for all required fields.

    8. The required field validation is not enforced for the Entered By field because users do not log into SoloSubmit. If Entered By is a required field, defects entered via SoloSubmit cannot pass the required field validation check.

  8. Select Use default values to initially populate the SoloSubmit web page with default values.

    9. SoloSubmit cannot determine which time zone to use as default values for date/time custom fields. When a defect is submitted via SoloSubmit, there is no associated user in the database. Consequently, there are no user options to check to determine which time zone to use. The current time of the computer the SoloSubmit CGI is running on, when the SoloSubmit page is loaded, is used as the default value for date/time custom fields. In addition, the date is assumed to be in the server’s time zone. The date/time is converted to GMT.

  9. Select fields you do not want JavaScript to handle field relationships for on the SoloSubmit web page.

    10. You would choose not to include the JavaScript for one of the following reasons:

    • The SoloSubmit web page includes hidden fields. For example, you comment out a field you do not want the customer to see. You can delete the HTML, but the field, and its values, will still show up in the JavaScript. If the customer chooses View Source on the SoloSubmit web page, the field and its values will be shown. Choosing not to include the JavaScript resolves this issue.
    • The SoloSubmit web page is customized and you do not want to overwrite the customization. For example, you only want a customer to be able to choose 3 out of 6 values for a field. You hard code a list of field values in the HTML. If you include the JavaScript, your customization is overwritten. By ignoring JavaScript for the field, the hard coded list values are used

      • If neither reason applies, and you select a field from the list, it could result in unexpected behavior. For example, you ignore JavaScript for Component, which is a child of Product. When SoloSubmit is accessed, Product and Component are populated with the initial values. If the user chooses a different Product, the Component values are not changed.

  10. Click OK or click another tab to continue setting options.
    11. Did you know? Remember to give users and customers the SoloSubmit URL. To submit bug reports or feature requests, they simply open a browser and enter the SoloSubmit URL (e.g., http://WysiCorp.com/ttweb/loginSoloSubmit.htm).


Setting report options

  1. Chose Edit > Options > Database Options.
  2. Click the Reports tab.
  3. Select a Look for new server stylesheets every time interval.

    4. The server periodically searches the database for new stylesheets and updates the stylesheet menus.

  4. Select a time zone option.

    5. Detail reports display the creation and modified time at the bottom of the report. Configure the report to use the server’s time zone or GMT.

  5. Select the time tracking fields.

    6. You can select which event time tracking fields to use for actual and estimated hours. When calculating the value, TestTrack Pro uses the selected events and determines which defect historical event(s) to use based on the “Sum of hours from all events of this type” or “Hours from last event of this type entered” event type setting.

  6. Click OK or click another tab to continue setting options.


Logging historical defect information

Historical defect logging is an optional feature used to record the changes made to a specific defect. Users can view what has changed in a particular defect record, who made the change, and when the change was made on the History tab. Following are some of the functions that generate a historical defect log message: Adding or editing a defect or adding, editing, or deleting a defect action; Adding, editing, or deleting a found by record; Merging defects; or Assigning a defect number or renumbering defects.


Enabling historical defect logging

  1. Choose Edit > Options > Database Options.
  2. Click the Defects tab.
  3. Select Enable logging of historical defect information.

    4. Disabling this option does not affect any information already logged in the database.


Deleting historical defect log information

If the database becomes too large because of historical log entries, you can delete entries. Deleting historical defect log entries does not reduce the amount of disk space used until the database is compressed. For more information, refer to the Server Admin Utility Guide.

Tip: To delete log entries for specific defects, select the defects before proceeding.
  1. Choose Configure > Delete Historical Defect Info.

    2. The Delete Historical Defect Info dialog box opens.

  2. Select the Delete Log Entry options.
    • Delete historical information regardless of log date deletes all log entries.
    • Delete historical information with dates prior to and including this date: deletes log entries prior to and including the date you enter.
  3. Click a Delete Log Entries For Which Defects? button.

    4. You are prompted to confirm the deletion.

  4. Click Yes.

    5. The defect historical log information entries are deleted.


Customizing the Workflow

Tailor your workflow…

...to match your existing processes. A customized workflow lets you define and follow your company’s business processes. Customize the workflow instead of asking your users to change how they work.


About the workflow

A workflow consists of states, events, and transitions that define the path a defect takes from initial reporting to resolution. TestTrack Pro’s standard workflow can be used “out of the box” to track software defects or you can customize the workflow to meet your company’s business processes.

The workflow guides all users that participate in the process and tracks their activities. The complexity of your workflow depends on the process. Simple processes may only require a few steps while more complex processes may include multi-user assignments and stricter resolution requirements.

States

States represent a step in the workflow. The status field indicates the current state. For example, a defect is Open, Awaiting Customer Verification. States can also include rules for processing multi-user assignments. Defects move from state to state based on transition rules.

Events

Events represent the action that can be performed at each state, or step, in the workflow. For example, a QA engineer must test a bug fix.

Transitions

Transitions specify the initial state when a defect is created and the events that can be added for each state. They move defects from one state to another. For example, the allowed events for a Fixed state are Assign, Verify, or Force Close.


Analyzing your workflow

Before you customize the workflow, you should take the time to document and understand your company’s business process. Analyzing your workflow helps you easily determine the states that are used, the actions that users perform, and how information moves through the workflow. A clearly defined workflow ensures that issues move from initial reporting to resolution and do not get stranded.

A carefully understood and customized workflow can guard against wasted time, redundancy, and disorganization. When analyzing your workflow, you should identify the steps that make up your business process and determine the actions that you want to associate with each step. The workflow should include a state for each step. In addition, consider the business process, the individuals involved in the process, the types of events they perform, the type of data they track, and the types of transitions that are used.

After the workflow is analyzed, you should be able to list most states, events, and transitions used throughout the process. To begin customization, you should first create the workflow states. Next, to transition defects, define the events that can be performed for each state. You can graphically view a workflow to help understand how the states, events, and transitions work together.


Customizing workflows

TestTrack Pro’s workflow can be used “out of the box” to track defects and other issues such as change requests. However, your company may have other processes you want to track. You can create multiple TestTrack Pro databases, each with its own customized workflow, to track additional company processes.

For example, you may want to create a TestTrack Pro database and customized workflow for your human resources department. Most companies have a defined process for hiring new personnel. Customize the workflow to provide an easy and convenient way for your human resources staff to track hiring new staff from receiving a staffing request from a manger to training a new hire.

To customize a workflow, perform the following steps:

  • Define states
  • Define events
  • Define transition rules, including multi-user assignments
  • Define state assignment rules
  • Configuring auto-assignment rules
  • Configuring notification rules
    • Note: All other users must be logged out before you can customize the workflow.

    It can be difficult to keep track of states, events, and transition and how they relate to each other. You can evaluate and graph the workflow to view potential problems and see a graphic representation of the workflow. See Evaluating the workflow and Graphing the workflow for more information.


Defining states

A defect is either open or closed. However, there are different states that an open or closed defect can have, based on process. For example, an open defect can be Open, On-Hold, Fixed, or Pending Verification. A closed defect can be Fixed, User Error, or Not Reproduced.

Your company workflow determines the number and variety of open and closed states. Each state includes a name, description, and attribute (open, closed).


Adding states

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens with the States tab selected. The States tab list the defined states.

  2. Click Add.

    3. The Add State dialog box opens.

  3. Enter a State Name and Description.
  4. Select an Attribute.
  5. Click OK.

    6. The state is added.


Editing states

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens with the States tab selected.

  2. Select a state and click Edit.

    3. The Edit State dialog box opens.

  3. Make any changes and click OK.

    4. Your changes are saved.


Inactivating states

To preserve historical information, inactivate a state instead of deleting it. You cannot inactivate a state if a defect is currently in the state.

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens with the States tab selected.

  2. Select a state and click Inactivate.

    3. You are prompted to confirm the inactivation.

  3. Click Yes.

    4. The state is inactive.

    Note: To activate an inactive state, select the state and click Activate.


Deleting states

You cannot delete states that are referenced in the database. If a state is referenced in the database, and you no longer want users to have access to it, inactivate it.

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens with the States tab selected.

  2. Select a state and click Delete.

    3. You are prompted to confirm the deletion.

  3. Click Yes.

    4. The state is deleted.


Defining events

Events define the activities that can be performed on a defect. Each event defines an operation in the workflow that may cause the defect to move to a new status, cause another operation such as assigning the defect to other users, or simply record that the event occurred. A defect’s history includes the events that have occurred for the defect. Some events are performed by users and other are automatic system events. For example, auto-assignment of defects based on auto-assign rules are system events.


Adding events

Events are accessed from the Activities menu or the defects shortcut menu.

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens.

  2. Click the Events tab.

    3. The Events tab lists the defined events.

  3. Click Add.

    4. The Add Event dialog box opens with the Details tab selected.

  4. Enter a Name and Description.
  5. Select any Details options. The Details tab specifies the event details that determine the resulting state after the event is entered and what optional pre-defined fields are added to the event dialog.
    • Select informational event to designate the event as an information-only event. Informational events can be added to the defect from any state in the workflow because they do not affect the workflow. When this option is selected, the assignment options are disabled.
    • Select a resulting state. The resulting state determines the state the defect moves to after the event is entered. You can also select multiple states if you want the user to choose a state. For example, you may want users to select a specific state for a fix event so you select Fixed, Closed, or Closed (Fixed) as the resulting states. When users enter fix events, they are prompted to select a resulting state.
    • Select an assignments option. These options indicate if the event results in an assignment. If Event results in a new assignment is selected, an assign to field is added to the event dialog.
    • Select Files can be attached to this event to let users attached files to the event. If this option is selected, an attachments section is added to the event dialog.
    • Select Display time tracking field using: to track event time. Then select an hours option. If time tracking is selected, a time spent field is added to the event dialog. For example, you want to track time for fix and estimate events. You can set the estimate event to only display the hours from the last estimate event. You can set the fixed event to display the sum of hours from all fix events. You can add these fields to a report to view the estimated time and actual time.
    • Select Include event notes with the release notes to add any event notes to the release notes.
  6. Click the Custom tab. The Custom tab is used to add custom fields and custom icons to the event.
    • Click Custom Fields to add a custom field to the event. If this option is selected, a custom fields section is added to the event dialog. See Configuring custom fields for more information.
    • Click Choose Icon to add a custom event icon to the TestTrack Pro Windows defect action toolbar. The icon must be a .bmp file that is 16x16 pixels or smaller. If you do not add an icon to an event, the event will only be available from the Activities and shortcut menus. See Defect action toolbar for more information.
    • Enter a graphic file name to add a quick link icon to the TestTrack Pro Web page. The web pages require two quick link icons, one for the enabled event and one for the disabled event. The disabled quick link icon should use the same name and be preceded with “d_”. For example, the disabled hire icon is named d_hir.gif because the enabled icon is named hire.gif. Both images must be added to the ttweb/images folder on the web server.
  7. Click the Fields tab. The Fields tab lists the standard fields that are displayed on the event dialog. The list includes the field name, the long label, and the field code. The field name may also be referred to as a short label.
    • Select a field and click Edit to edit the name, the long label, or the field code.
    • Make any changes and click OK.
      • Did you know? Field names, or short labels, are displayed in generated event dialogs. Long labels are displayed in dropdown lists. Long labels help users distinguish between the same fields in different events. Field codes automatically generate data and are used with such things as email templates or reports.
  8. Click OK.

    9. The event is added.


Editing events

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens.

  2. Click the Events tab.
  3. Select an event and click Edit.

    4. The Edit Event dialog box opens.

  4. Make any changes and click OK.

    5. Your changes are saved.


Inactivating events

To preserve historical information, inactivate an event instead of deleting it.

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens.

  2. Click the Events tab.
  3. Select an event and click Inactivate.

    4. You are prompted to confirm the inactivation.

  4. Click Yes.

    5. The event is inactive.

    Note: To activate an inactive event, select the event and click Activate.


Deleting events

You cannot delete events that are referenced by the transitions tab or that are part of any defect’s historical events.

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens with the States tab selected.

  2. Select an event and click Delete.

    3. You are prompted to confirm the deletion.

  3. Click Yes.

    4. The event is deleted.


Defining transitions

Transitions specify the initial state when a defect is created and the events that can be added for each state. Transitions help enforce the workflow by enabling event menu items and icons based on the current state of the defect. You can quickly view the events that are enabled for each state. You can also edit transitions to add or remove allowed events for each state.


Selecting the initial defect state

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens.

  2. Click the Transitions tab.
  3. Select the initial state for new defects.

    4. All new defects will be added in the selected state.

  4. Click OK.


Editing transitions

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens.

  2. Click the Transitions tab.
  3. Select a state to view the allowed events.
  4. Click Edit to add or remove the allowed events.

    5. The Edit Transitions dialog opens.

  5. Add or Remove events.
  6. Click OK.

    7. Your changes are saved and you return to the Customize Workflow dialog.

  7. Click OK.


Defining assignment rules

Assignment rules specify how state assignment events are processed. You can restrict which users can enter an event, specify multi-user assignment options, and change the process order of rules.

  1. Choose Configure > Workflow Rules.

    2. The Customize Workflow dialog opens.

  2. Click the Assignment Rules tab.

    3. Select a state to view its assignment rules and resulting state priorities.

  3. Select a state and click Edit to change assignment rules or the resulting states priority.

    4. The Edit Assignment Rules dialog box opens.

    Note: The options change based on the assignment rules you select. For example, if Use the state entered by the first user to respond is selected, the resulting states priority cannot be changed because priority does not affect the select option.
    • Select Only allowed assigned users to enter an event when the defect is in the selected state to make sure that only assigned users can enter an event. For example, your review process requires users to sign-off and accept changes. Selecting this option ensures that all assigned users enter an event when the defect is in the selected state.
    • Select a multi-user assignment rules option to determine the resulting state if a conflict occurs. Defects may have different resulting states when they are assigned to multiple users.
    • To reorder the resulting states priority, select a state and click Up or Down.
  4. Click OK.

    5. Your changes are saved.

    Did you know? Use state entered by first user to respond processes the event entered by the first user and moves the defect to the corresponding state. If the event moves the defect to a new state or affects the current assignment, the remaining assignments are removed. If the event leaves the defect in the current state or does not affect the current assignment, the remaining assignments are not removed and users can still enter events. For example, the first user enters a “Verify Fixed” event. The defect moves to “Close” and the other assigned users are removed from the list of current assignments.

    Wait for all assigned users to respond then use the state with the highest priority accepts events from assigned users then uses the event with the highest resulting state to determine the next state. For example, one user enters “Verify Fixed” resulting in a Close state and another user enters “Verify Failed” resulting in an “Open” state. The defect moves to “Open” because it has the highest priority.

    Use the state with the highest priority and proceed as soon as an event with the highest priority is entered accept events from assigned users until an event with the highest resulting state priority is entered or until all users have responded. If all users respond, and an event with the highest resulting state is not entered, the highest resulting state of the entered events is used. For example, “Open” is the highest resulting state. As soon an event with “Open” as a resulting state is entered, the defect moves to “Open” and the assignment list is cleared. If all users enter events with “Close” as a resulting state, the defect moves to “Close”.


Configuring auto-assignment rules

Auto-assignment rules, which only run if a defect is not assigned to a user when changes are saved, automatically move a defect from state to state and assign the defect to a specified user. When a defect is moved into a state with an auto-assignment rule, TestTrack Pro checks the rules in top-down order. If the defect passes a filter, the assignment action is applied. If the defect does not pass the filter, the next rule is checked until the defect passes a filter. If the defect does not pass any of the filters, the default action is applied.

Note: You can also select a default auto-assignment action to use if you do not want to configure rules or if a defect does not pass the auto-assignment rule filter. For more information, see Setting default actions.

For example, if your team is in Beta testing, you want to make sure that defects failing verification get immediate attention. If the Defect fails verification, two auto-assignment rules are checked. If the defect’s filter is Failed Fix, the defect is automatically assigned to the last Fixed by User. This user can review why the fix failed and make the necessary adjustments so the defect can pass. If the filter is not Failed Fix, the second rule is checked. If the defect’s filter is On hold, the defect is automatically assigned to the project administrator. The administrator determines if the issue needs to be resolved in Beta or at a later time.

Auto-assignment rule exceptions

Auto-assignment processing is skipped when a defect is created using XML import, text import, or by duplication. For example, if you duplicate a defect that is unassigned, the new defect is also unassigned. If you duplicate a defect that is assigned to Barry, the new defect is also assigned to Barry.


Adding auto-assignment rules

  1. Choose Configure > Auto-Assignment Rules.

    2. The Configure Auto-Assignment Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Click Add.

    4. The Add Auto-Assignment Rule dialog box opens.

  4. Enter a Rule Name.
  5. Select a Rule Filter.

    6. The filter list displays the public and private filters you have access to.

  6. Select an auto-assign Action.
    • Make it unassigned does not assign the defect to a user.
    • Assign to the entered by user assigns the defect to the user who entered the defect.
    • Assign to the found by user assigns the defect to all found by users, the first found by user, or the last found by user.
    • Assign to the last user(s) to enter... assigns the defect to the user who last entered the selected defect event. The list includes all of the events defined for the workflow in the database. If the last user entered the event in response to a multi-user assignment event, the auto-assignment is applied to all users who responded to the event.
    • Assign to the following user(s) assigns the defect to the selected users or customers.
  7. Select an Assign Event.

    8. To save rules, select a valid assign event from the dropdown list. Valid events must be active, result in a new assignment, and only allow <No State Change> as the resulting state.

  8. Click OK.

    9. The rule is added.

    Note: Rules are checked in top-down order. To change the rule order on the Configure Rules dialog, select a rule and click Move Up or Move Down.


Setting default actions

You can set a default action for each defect state if you do not want to configure auto-assignment rules.

  1. Choose Activities > Configure > Auto-Assignment Rules.

    2. The Configure Auto-Assignment Rules dialog box opens.

  2. Select a defect state and click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Select a Default action and click OK.

    4. You should set a default action for each defect event.


Editing auto-assignment rules

  1. Choose Configure > Auto-Assignment Rules.

    2. The Configure Auto-Assignment Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Select a rule and click Edit.
  4. Make any changes and click OK.

    5. Your changes are saved.


Inactivating auto-assignment rules

If there is a rule that is no longer in use, inactivate it instead of deleting it. You can easily activate the rule if you decide to use it again.

  1. Choose Configure > Auto-Assignment Rules.

    2. The Configure Auto-Assignment Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Select a rule and click Inactivate.

    4. The rule is inactivated.

    Note: To activate an inactive rule, select the rule and click Activate.


Deleting auto-assignment rules

Delete rules if you are certain you will not use the rule again. You can also inactivate a rule to disable it.

  1. Choose Configure > Auto-Assignment Rules.

    2. The Configure Auto-Assignment Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Select a rule and click Delete.

    4. The rule is deleted.


Configuring system notification rules

Configure system auto-notification rules to automatically inform users about events, such as status changes, via email. Email notifications can be configured for each state defined for defects. Notifications only inform users of the event change, they do not assign users a task. System auto-notifications rules are configured by the administrator and are run in addition to any personal email notifications users set up.


Adding system notification rules

  1. Choose Configure > System Notification Rules.

    2. The Configure System Notification Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure System Notification Rules dialog box opens. The notification name is listed in the top left corner of the dialog box.

  3. Click Add to add a rule.

    4. The Add Notification Rule dialog box opens.

  4. Enter a Rule Name.
  5. Optionally select a Rule Filter.

    6. If a database contains a large number of defects, you may want to filter the defects the rule is applied to. If you need to add filters, see Creating filters.

  6. Select a Recipient.
    • Send to the entered by user sends the email notification to the user who entered the defect.
    • Send to assigned user(s) sends the email notification to all assigned users.
    • Send to the found by user sends the email notification to all found by users, the first found by user, or the last found by user.
    • Send to the last user(s) to enter... sends the email notification to the user who last entered the selected defect event. The list includes all of the events defined for the workflow in the database. If the last user entered the event in response to a multi-user assignment event, the notification is sent to all users who responded to that event.
    • Send to the following user(s) sends the email notification to the selected users or customers.
  7. Select an Email Template.

    8. Remember, users will be able to view all information in the email that is sent. For example, you add a system notification rule that sends an email when a customer reports a defect. Do not select an email template that includes restricted information, such as the defect status or the defect number. You may not want customers to have access to this information.

  8. Select Don’t send email if current user made the change if you do not want the user who made the change to receive an email notification. For example, if JoeQA changes a defect, he probably does not need to be sent an email notifications regarding the status change.
  9. Select Only send email if defect is assigned to current user if you only want the assigned user who made the change to receive an email notification.
  10. Click OK.

    11. The rule is added.


Editing system notification rules

  1. Choose Configure > System Notification Rules.

    2. The Configure System Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Select a rule and click Edit.
  4. Make any changes and click OK.

    5. The changes are saved.


Inactivating system notification rules

If there is a rule that is no longer in use, inactivate it instead of deleting it. You can easily activate the rule if you decide to use it again.

  1. Choose Configure > System Notification Rules.

    2. The Configure System Notification Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Select a rule and click Inactivate.

    4. The rule is inactivated.

    Note: To activate an inactive rule, select the rule and click Activate.


Deleting system notification rules

Delete rules if you are certain you will not use the rule again. You can also inactivate a rule to disable it.

Note: Make sure you want to delete the rule. You are not prompted to confirm the deletion and this action cannot be undone.
  1. Choose Configure > Auto-Notification Rules.

    2. The Configure System Notification Rules dialog box opens.

  2. Click Configure Rules.

    3. The Configure Rules dialog box opens.

  3. Select a rule and click Delete.

    4. The rule is deleted.


Overriding the workflow

If a defect is assigned to multiple users and events can only be entered by assigned users, the defect can be delayed if a user is out of the office or busy with other tasks. You can override the workflow to move the defect to another state.

  1. Open the defect you need to override the workflow for.

    2. All workflow events are disabled after the defect is open.

  2. Choose Activities > Override Workflow.

    3. The valid events for the current state are enabled.

  3. Select an event from the Activities menu.

    4. The defect moves to the resulting state for the selected event. A workflow override entry is added to the workflow tab.


Evaluating the workflow

When you customize a workflow, you may find it helpful to periodically evaluate the workflow for potential issues. If any issues are found, you can correct the issues before continuing. For example, if a state is set to only allow assigned users to enter an event for that state, but the state can be reached through an event other than as assign event, it is returned as a potential issue that should be fixed.

  1. Choose Configure > Workflow Rules.

The Customize Workflow dialog opens.

  1. Click Evaluate Workflow.

The Potential Issues dialog opens. All potential issues are listed on the dialog.

  1. Click Save As to save the information as a text file.
  2. Click OK to close the dialog.


Graphing the workflow

Graph the workflow to view a visual representation of the workflow. This can help you solve issues and quickly view configured states and events the state, events, and transitions.

  1. Choose Configure > Workflow Rules.

The Customize Workflow dialog opens.

  1. Click Graph Workflow.

The Workflow Graph dialog opens.

  1. Click Save As to save the workflow as a .jpg file.

    2. Saving the workflow as a .jpg file provides easier viewing and lets you scale the image for printing.

  2. Click Page Setup to change the printer options such as paper size.
  3. Click Print to print the workflow.


Customizing Fields

Customize fields...

to collect the data you need. The data you collect is one of the most important parts of the defect tracking process. TestTrack Pro lets you customize fields to meet your company’s requirements and make sure users are providing the information you need. You can also rename field labels and change existing field data.


Configuring list values

You can configure menu list values to customize TestTrack Pro with your company’s terminology. The list values you configure are database-specific. You can configure type names, priority names, severity names, product names, component names, disposition names, reproduced names, fixed resolutions, closed resolutions, and version names.


Adding list values

  1. Choose Configure > List Values. Then select the group you want to add the field to. This example uses disposition, which is a child field.

    2. The Setup Disposition Names dialog box opens. The setup dialog box changes based on the field type. For example, if you add a value to a parent field, you are reminded to configure field relationships for the new value.

  2. Click Add.

    3. The Add Disposition dialog box opens.

  3. Enter a disposition field name and click OK.

    4. You return to the Setup Disposition Names dialog box.

  4. Select the association for the field. Remember, in this example, disposition is a child field.

    5. You can associate the new child field with all of the parent menu items or none of the parent menu items.

    Tip: You can also manually configure the parent-child field relationship. Go to Configure > Field Relationships. For more information, see Defining required fields and default values.
  5. Click OK when you finish adding field values.


Editing list values

  1. Choose Configure > List Values then select the group containing the field value you want to edit.
  2. Select the name and click Edit.

    3. The Edit Defect Type dialog box opens.

  3. Enter a new name and click OK.

    4. The list is updated with the new name. To reorder field names, select the name and click the Up or Down button. You can also sort all field names in ascending or descending order.


Deleting list values

  1. Choose Configure > List Values then select the group containing the field name you want to delete.
  2. Select the name and click Delete.

    3. If the field name is used by a defect, you are prompted to reassign the field name to one of the existing field values. The field value cannot be deleted until it is reassigned.

    Did you know? If a database uses field relationships and you delete an item from a menu, you may cause a child field’s value to no longer follow field relationship rules. If you try to delete a field that is used in a field relationship, you will receive a warning indicating the action may result in defects that do not follow the field relationship rules.


Configuring custom fields

You can add up to 100 custom fields to a database. All custom fields can be displayed on the Custom Fields tab or up to two custom fields can be displayed in the main area of the Add Defect, Edit Defect, and View Defect dialog boxes.


Adding custom fields

Note: Make sure all users are logged out of TestTrack Pro. You cannot add custom fields if other users are logged in.
  1. Choose Configure > Custom Fields.

    2. The Set Up Custom Fields dialog box opens.

  2. Click Add.

    3. The Add Custom Fields dialog box opens.

  3. Enter a Field name.

    4. The name can be up to 20 characters long.

  4. Select a Field type.
    • Edit box lets users enter a value. After choosing this field type, select string, integer, or decimal number as the Field format and enter the Maximum field size.
    • Date/Time creates a date/time field. When users select this type of custom field, the current date and time is set. Users can change the date and time
    • Check box creates a check box field. The check box custom field works the same as other check boxes; users select or clear the check box.
    • Pop-up menu lets you define the menu values. After choosing this field type, click Setup Pop-Up Menu Items to add values to the pop-up menu.
      • Note: If you add a field that will be used in a field relationship, select Pop-Up Menu. This field type lets you restrict the information users can enter.
  5. Click OK.

    6. You return to the Setup Custom Fields dialog box.

  6. Select the Display Location options.

    7. You can display all custom fields on the Custom Fields tab or display up to two custom fields on the Add, Edit, and View Defect dialog boxes.

  7. Click OK.
    8. Note: TestTrack Pro assigns a field code to the custom field. The field code lets you use the custom field in an email template or in a report template.


Editing custom fields

  1. Choose Configure > Custom Fields.
  2. Select the custom field and click Edit.

    3. The Edit Custom Fields dialog box opens.

  3. Make any changes and click OK.

    4. You cannot change the Display Location option if other users are logged in to TestTrack Pro. To edit this option, all users must be logged out.

  4. Click OK.


Deleting custom fields

  1. Choose Configure > Custom Fields.
  2. Select the custom field and click Delete.

    3. You are prompted to confirm the deletion.

  3. Click Yes.

    4. The custom field is deleted.

  4. Click OK.


Defining required fields and default values

TestTrack Pro lets you select any defect or defect action input field, including custom fields, and make it a required field. When a field is required, it means a user must enter data in that field before TestTrack Pro will add the defect or defect action to the database or save any edit changes. You can also define default values for most fields on the Add Defect or Defect Action dialog box. Required fields and default field values are database-specific.

Did you know? Required fields are set for all users. Field level security is set for Customer and User Groups. For example, the Priority field is required but does not have a default value. A Customer Group is created, with permissions to add defects. The Priority field is hidden for both Add and Edit privileges. Customers find out they are not able to add defects. Why? The Priority field is required but the Customer Group does not have access to the field. An easy workaround is to grant access to the Priority field when adding defects and hide the Priority field when editing defects.

The required field must be populated for all instances of actions. For example, the Found By field is required and does not have a default value. When multiple detail records are created for a single defect, the Found By field must be populated for all of the detail records.
  1. Choose Activities > Required Fields & Default Values.

    2. The Required Fields & Default Values dialog box opens.

  2. Select the field group from the menu.

    3. Field types are grouped together for easy reference.

  3. To set a required field, select the corresponding check box.

    4. A field that is set using check boxes and/or radio buttons cannot be set as a required field.

  4. To set a default value, select a value from the corresponding menu.
  5. Repeat steps 2 - 4 until required fields and default values are set for each group.
  6. Click OK.

    7. If a field is always required, the check box is selected and inactive. If a field cannot be set as a required field, the check box is not selected and it is inactive. If a default value cannot be set for a field, the menu value is labeled <blank> and it is inactive.


Editing required fields and default values

  1. Choose Activities > Required Fields & Default Values.

    2. The Required Fields & Default Values dialog box opens.

  2. Select the field group you want to edit from the menu.
  3. To clear a required field, click the corresponding check box.

    4. The field is no longer required.

  4. To change a default value, select a different value from the corresponding menu.
  5. Click OK to save your changes.
    6. Did you know? How do default values affect field relationships?
    A child field’s default value may be invalid, depending on the parent field’s default value. If a default value is selected, and it does not follow the defined field relationships, the default value can still be used but the child field’s value will no longer follow field relationship rules.

    How do hidden fields affect field relationships?
    A child field that is hidden can cause unintended changes. If you change a parent field, you may cause a child field’s value to no longer follow field relationship rules. Additionally, if the child field is required, any changes that are made cannot be saved.


Configuring field relationships

You can define parent-child field relationships that create dependent items in the database. This lets you configure the menus so users can only select values based on the parent-child field relationship. This helps users input better data and make more logical choices. Before you begin configuring field relationships, you should think about how to best use this powerful feature.

  • The following fields can be set as parent fields: type, product, disposition, priority, component, severity, custom fields.
  • The following fields can be set as child fields: type, product, disposition, priority, component, severity, version found, reproduced, computer config, custom fields.
  • The following fields cannot be set as parent or child fields: entered by, found by, fixed by.
    • Did you know? When a field is chosen from a menu, and there is a parent-child relationship, the child field is populated with values based on the parent field.

    For example, Product is the parent field of Component and Version. Component is the parent field of Routine, which is a custom field. When a user adds a defect, the Component and Version fields are populated based on the selected Product field value. The Routine field is populated with values based on the selected Component field value.


Adding field relationships

  1. Choose Configure > Field Relationships.

    2. The Field Relationship Selection dialog box opens.

    Note: If you are use a custom field in a field relationship, it must be configured as a pop- up menu field. For more information, see Adding custom fields.
  2. Click Add.

    3. The Setup Parent-Child Relationship dialog box opens.

  3. Select the parent field from the menu then select the child field and click OK.

    4. The Setup Field Relationships dialog box opens.

  4. For each field in the parent list, enable or disable the child list fields.

    5. The child list displays each of the child field values with the default state for each value selected. If you add additional field values to the child list, the values automatically appear unless they are disabled.

    Note: A parent field can have one or more child field relationships. A child field can only have one parent. A child field can also be the parent of another field.

    When a field is set as a child field, it is excluded from the child field list. For example, Priority is the child field of Severity. When you add a field relationship, you cannot select Priority as a child field.

    To prevent a circular reference, fields that are a parent or grandparent of the selected parent field are excluded from the parent list. For example, Product is the parent field of Component. Component is the parent field of Version. You cannot set Version as the parent field of Product because a circular reference is created.
  5. Click OK when you finish setting up the field relationship.

    6. You return to the Field Relationship Selection dialog box.

  6. Click OK to close the dialog box or click Add to add another field relationship.
    7. Did you know? What if a database uses default values?
    The child field’s default value may be invalid, depending on the parent field’s default value. If a default value is selected, and it does not follow the defined field relationships, the default value can still be used.

    What if a database uses hidden fields?
    Hidden fields can cause unintended changes. If a parent field is changed, causing the child field value to be, the child field may be changed to <not set>, depending on database options. Additionally, if the child field is required, any changes that are made cannot be saved.


Editing field relationships

  1. Choose Configure > Field Relationships.

    2. The Field Relationship Selection dialog box opens.

  2. Select the field relationship and click Edit.

    3. The Setup Field Relationships dialog box opens.

  3. Make any changes and click OK.


Deleting field relationships

  1. Choose Configure > Field Relationships.

    2. The Field Relationship Selection dialog box opens.

  2. Select the field relationship and click Delete.

    3. You are prompted to confirm the deletion.

  3. Click Yes.

    4. The field relationship is deleted.


Renaming field labels

You can rename defect field labels to match your company’s terminology. This helps you customize your tracking system and decrease user confusion. Renaming a field label does not change the functionality or format of the field, it only changes the label displayed in TestTrack Pro.

Did you know? For example, your company uses case numbers. Rename reference to case numbers so users know where to enter the case number information. Or, your your company refers to issues instead of defects. Rename all instances of defect (Defect, defects, defect(s), etc.) to issue. If you are a service-oriented organization, and use the Custom Fields tab to track service issues, you can rename the tab to Service.
  • The following field labels can be renamed: Summary, Type, Disposition, Priority, Product, Component, Reference, Severity, Entered By, Date Entered, Status, Found By, Date Found, Date, Version Found, Version, Description, Reproduced, Steps to Reproduce, Computer Config, Other Hardware and Software, and the Custom Fields tab label.
  • The following words can be renamed: Defect / defect, Defects / defects, Defect(s) / defect(s).
    1. Choose Configure > Rename Field Labels.

      2. The Rename Field Labels dialog box opens.

      Did you know? Date is the short form of Date Found. Version is the short form of Version Found. If you rename these field labels, use the same terminology. The short and long field names are both used. The short name is used to allow fields to fit in the user interface.
    2. Select the field you want to rename and click Edit.

      3. The Edit Field Label Value dialog box opens.

    3. Enter the Field Label and click OK.

      4. Field labels cannot be resized in the user interface and should not be longer than 32 characters. Field labels that do not fit in the allotted space are truncated.

    4. Repeat steps 2 and 3 for each field label you want to rename.
    5. When you finish, click OK on the Rename Field Labels dialog box.

      6. Your changes are saved and the database is updated with the new field labels.

      Note: Field renaming does not affect image files. In the Web interface, the tabs are image files (.gif). For example, if you rename the Custom Fields tab to Services, it will only affect the Windows client. To change the tab name in the Web interface, you can manually modify the graphic. Image files are generally stored in: Inetpub/wwwroot/ttweb/images. Most graphics include two images: one for a selected tab and one for a non-selected tab.


Restoring original labels

You can restore the field labels to their original values at any time.

  1. Choose Activities > Rename Field Labels.

    2. The Rename Field Labels dialog box opens.

  2. Click Restore to Original Values.

    3. The field labels revert to the original values.

  3. Click OK to save the changes. If you do not want to save the changes, click Cancel then click No.
    4. Did you know? Changes you make to field labels do not show up in SoloBug. As a stand-alone product, SoloBug is not necessarily associated with one database. Field names can be changed when you customize the SoloBug executable.

    Field codes do not change. For example, Disposition (%DISP) is renamed to Substatus. You want to include the Substatus field data in an email template. You would use %DISP% to return the field data. There are field codes that can be used to return the label name. For more information, see .

    Database columns are not renamed. When you use the ODBC driver, you need to use the original field name in your queries.


Configuring SCC Integration

Integrate your SCC solution...

with TestTrack Pro! In just a few minutes, you can configure SCC integration and associate specific defects logged in TestTrack Pro with your source code.


About SCC applications and TestTrack Pro

Among other SCC functions, users can attach and detach source files to and from defects. Users can also check out the code to fix a defect, while viewing the defect. When checking in code, users can apply the same comment to all components.You will know when and why code changed and what new changes need to be included in your next build. The following SCC applications can be integrated with TestTrack Pro:

  • CS-RCS
  • CVS
  • ClearCase
  • PVCS
  • Perforce
  • SourceOffSite Classic
  • StarTeam
  • Surround SCM
  • Visual SourceSafe

Configuring SCC integration

Did you know? Make sure you create a user group that can access source code control commands, including the SCC tab. Remember, all users must configure their local and user options.
  1. Choose Configure > SCC Integration.

    2. The Configure SCC Integration dialog box opens with the Local Options tab selected. The Local Options tab is the only tab available until you select an SCC application.

    Note: CVS is always displayed in the Available Providers list. Do not set up CVS integration if CVS is not installed on your computer.
  2. Select the application you want to use from the Available Providers list and click Make Current.

    3. The application you selected is listed in the Current box.

  3. Click the User Options tab.

    4. This tab is used to select the project database and enter a username and password to connect to the database.

    Note: The user options settings are stored in the TestTrack Pro database for the currently logged in user. If you log in to multiple TestTrack Pro databases, SCC user options must be configured for each database.
  4. Click Browse to select the project database.

    5. If you use Visual SourceSafe or PVCS you must also enter a valid username and password for the database.

  5. Click Validate Connection to test the connection parameters.

    6. If the connection fails, make sure you selected the right project database and entered the correct username and password information.

  6. Click the Database Options tab.

    7. You can customize check in comments, using field codes. When users check in files, the comments field is populated automatically. For more information, see .

  7. Click the Project Paths tab.

    8. Select the project paths you want users to access. Expand the root directory, select a path, and click Add.

    Note: If you select the root directory, users can access all files in the database. To limit the files users can access, select specific directories.
  8. Click the Check In Options tab.

    9. If Include options to enter fix event on check in is selected, the fix event dialog is opened when a user checks in a file. This lets users add a fix event when checking in a file.

  9. Click OK when you finish configuring the SCC integration.

    10. For more information, see Using source code control with TestTrack Pro.


Disabling SCC integration

  1. Choose Configure > SCC Integration.

    2. The Configure SCC Integration dialog box opens.

  2. Select the provider you want to disable and click Disable SCC Integration.
  3. You are prompted to confirm that you want to disable the SCC integration.
  4. Click Yes.


SCC application notes

The following application-specific information is provided to help you easily integrate SCC applications with TestTrack Pro.

CS-RCS

If you configure CS-RCS to work in CVS mode, the Check out, Check in, and Undo Check out buttons are still shown on the SCC tab, which can be confusing. The buttons may also be enabled/disabled for certain files, depending on the state of the file. Generally, these buttons are always enabled when CS-RCS is running in CVS mode.

CVS

Valid CVS working directories must be setup before you try to use the integration. The integration cannot be used to get the first copy of a your working files. This includes any local directories, which must exist before you can use the integration. To set up the integration:

  1. Enter the local working path in the Project working path field.

    2. The Project Paths settings are based on the information you enter. After you enter a working directory, go to the Project Paths tab and add specific paths to use in the Attach dialog.

  2. Enter the connection string in the Repository connection string field.

    3. This string should be what you use for the -d option on the CVS command line

  3. If you use a password, enter it in the SCC Password field.

    4. You can also enter the password as part of the connection string. If you enter the password in the connection string, it can be viewed by anyone looking at your computer. If security is an issue, enter it in the password field.

  4. If a merge is required when checking in a file, you must manually perform the merge. When you try to check in the file, you will receive a message letting you know a merge is needed. You have to manually perform the merge and then check in the file.

ClearCase

  • The Get command is only valid for snapshot views. It is not valid for dynamic views.
  • Files from different views are displayed on the Source Code tab. If you configure TestTrack Pro to connect to a dynamic view, and you have also attached files that are part of a snapshot view, all files are displayed. In this case, the Get command is invalid for any files that were attached in the dynamic view.

PVCS

  • PVCS uses its own dialogs to handle opening the project and authenticating the user. PVCS prompts you for login data each time you open the project database.
  • Two different TestTrack Pro users cannot configure PCVS integration, to separate PVCS projects, under one Windows user account.

Perforce

  • The Browse button is disabled on the User Options tab. The client name is used for the project database. The login for the Perforce depot comes from the Perforce registry keys. The P4USER and P4PASSWD keys must be set correctly before the TestTrack Pro integration will work.
  • Only the first 31 characters of a file’s check in comments can be displayed when viewing file history (SCC tab, History button).

SourceOffSite Classic

  • You must have the SourceOffSite GUI client installed on each computer you are using SourceOffSite integration with in TestTrack Pro. You also need to install the command line version and place it in the same directory as the SourceOffSite client.
  • You should not run the SourceOffSite client and the TestTrack Pro integration at the same time. This is a SourceGear recommendation.
  • SourceOffSite does not provide an easy way for TestTrack Pro to get the local path for a VSS file. TestTrack Pro looks at the databasex.sos cache file to get the directory information. If that does not work, the calls rely on the SourceOffSite GUI client to access the cache and provide the information.
  • The Get, Check out, and Undo check out commands overwrite files without prompting you for permission.
  • The SourceOffSite command line API has a bug in it and cannot copy files to root drives correctly. If TestTrack Pro does not get the local path information from the cache, the Get and Check out commands will not work with files that use a root drive for the working path. The View command will not work because TestTrack Pro does not know the file location.
  • A valid cache file must exist for each user’s server/database configuration.
  • Logging into a server with two different names (e.g., 127.0.0.1 and localhost) results in two separate cache files. If you set up the SourceOffSite client to log in to 127.0.0.1 and configure TestTrack Pro to login to localhost, the integration will not work as expected. The localhost cache file will not have any working paths setup. This problem also occurs if you do not set up working paths in your SourceOffSite client. SourceOffSite will put the files in the current directory (e.g., c:\Program) instead of returning an error.
  • The Login area of the User Options tab includes Server and Port fields that let you enter the server’s connection data. After entering this data, click Browse. A list of available databases available on the server opens.
  • The SourceOffSite command line application does not create directories when retrieving files. If you attempt to Get or Check out a file to a directory that does not exist, the call fails. You can create the directory path then perform the Get or Check out command.
  • If the SourceOffSite server or the command line application crash, you need to close the TestTrack Pro client, restart the SourceOffSite server, then restart the TestTrack Pro client. TestTrack Pro is still usable if SourceOffSite crashes. The SourceOffSite integration will not work until you restart TestTrack Pro.

StarTeam

  • Make sure your files are set up before configuring the SCC integration. If files are not set up in the project working path, and you configure the SCC integration, you will receive an error message in the Project Tree.
  • StarTeam uses its own dialogs to handle opening the project and authenticating the user. StarTeam prompts you for login data each time you open the project database.
  • Two different TestTrack Pro users cannot configure StarTeam integration, to separate StarTeam projects, under one Windows user account.

Surround SCM

none

Visual SourceSafe

none


Managing User Groups

Safe and Secure!

User groups control security and the TestTrack Pro commands a user can access. Protect your data integrity, and security, by creating user groups for all security levels.


About security

TestTrack Pro’s security options let you configure your database to provide as much, or as little, access as needed. TestTrack Pro includes the following security options:

  • Password security, which users set, limits access to databases.
  • Command security limits which commands a group of users can execute.
  • Field security limits who can enter data into, or alter the contents of, each defect field.
  • Defect security limits the defects that are visible to each user group.
  • Advanced defect logging can track who changed defect fields and states and when the change was made.
  • Server logging records unusual activity, critical, and non-critical system issues.


About user groups

A user group is a collection of users who share responsibilities and perform similar tasks. Users must be assigned to a user group before they can work with TestTrack Pro databases. Access to TestTrack Pro functions, such as adding a defect or using SCC integration, is controlled by the group security.

When you set up a database, create the user groups first. This lets you create a security structure for the users. You can create an unlimited number of security groups and levels. Security determines what databases users can access, what their view and edit rights are for authorized projects (on a per-field level), and what they can do at each stage of the workflow process.

Before you start creating user groups, you may find it helpful to list the types of users you will be adding to the database and what their needs are. You can add as many or as few user groups as you need, and make their security levels as general or as command-specific as you need.

Tip: If you want all users to have access to all commands, you do not need to create user groups. TestTrack Pro adds an Administration user group when a database is created. This user group has access to every command. Simply add the users to this default user group.

The following example provides security based on group levels:

Group Name | Security Level | Commands Granted
Level 1 | Low | View
Level 2 | Medium | View, Add
Level 3 | High | View, Add, Edit
Level 4 | Highest | View, Add, Edit, Delete

Or, using the same structure, name the user groups according to job description:

Group Name | Clearance Level | Commands Granted
Tech Writer | Low | View
Engineer | Medium | View, Add
QA Tester | High | View, Add, Edit
Manager | Highest | View, Add, Edit, Delete


User groups and security

TestTrack Pro security is assigned at the user group level. Each user group can be assigned different levels of security. You can set command, field, and defect security in TestTrack Pro.


Command-level security

Command security limits the commands a group of users can execute. Command security includes the following categories: General, Administration, Defects, Customers, Users, User Groups, Test Configurations, Filters, Reports, and Workbook.

It is obvious how most of the command-level security options work. For example, the Add Customer command determines if a user can access the Add Customer dialog. There are other command-level security options that require more explanation.

  • Edit User security lets a user edit user information for every TestTrack Pro user. The Edit Own General User Settings and Edit Own Notifications options let users set their own options only.
  • Edit Own General User Settings security determines if a user can view the General tab on the User Options dialog box. This tab lets the user set their own TestTrack user options.
  • Edit Own Notifications security determines if a user can view the Email tab on the User Options dialog box. This tab lets the user set their own email notification options.
  • Configure SCC DB Options security determines if a user can view the Database Options tab and the Project Paths tab on the Configure SCC Integration dialog box. Any changes made to the options on these two tabs affect all users in the TestTrack database.
  • See SCC Tab security determines if a user can view the Source Code tab on the Add/Edit Defect window. This option only lets the user view the SCC actions that have already been performed; it does not provide security access to perform SCC actions. If a user does not have See SCC Tab security or Configure SCC DB Options security, then the Configure SCC Integration menu option is also disabled because these options do not apply.
  • Perform SCC Actions security determines if a user can perform SCC actions such as check in and check out. Because these actions can only be performed from the Source Code tab of the Add/Edit Defect window, the user also needs the See SCC Tab security.


Defect-level security

Defect security restricts limits which defects are visible to the user group based on an existing filter and/or whether the user reported the defect. Defects that do not pass the filter are not displayed in the defect list or included in reports.

For example, you have a group of managers who only need information about feature requests. Select the Open Feature Requests filter for this group. The managers can only view defects that meet the filter criteria.


Field-level security

Field security affects defects and defect actions and restricts a user’s ability to enter, or edit, field data. For example, can a user enter a resolution in the fix defect action field?

Three types of field security can be assigned: Read/Write, Read Only, and Hidden. In addition, Add and Edit privileges are set separately. For example, assign a restricted user group read/write add privileges for the Type field. Assign the same user group read only edit privileges for the Type field. When adding a new defect, users can enter information for the type field. When editing a defect, users can view the Type field but will not be able to make any changes.

Security can be assigned to the following fields: General, Found By, Assigned, Estimated, Fixed, Release to Test, Verified, Release to Customer Test, Customer Verified, Closed, Reopen, Release Notes, Comment, and Custom fields.

Field security cannot be applied to the following areas: email templates, SoloSubmit, SoloBug, and import/export.

System-generated fields cannot be assigned field security. This includes the following fields: defect number, defect status, has attachments?, has workaround?, date created, created by, creation method, date last modified, last modified by, found by group, found by company, how many?, and has release notes?

Did you know? This example shows how to use Add privileges to set up field security:

Assign the Department Manager group Read/Write access to the Priority field. Users in the Department Manager group can set the priority level. Assign the Programmer group Read Only access to the Priority field. Users in the Programmer group can view, and not edit, the priority level. Assign the Customer group Hidden access to the Priority field. Users in the Customer group cannot view the priority level assigned to defects.


Adding user groups

  1. Choose Create > User Group or click Add on the User Group list window.

    2. The Add User Group dialog box opens.

  2. Enter a Name and Description.

    3. These fields are required.

  3. Add users to the group. Select a user from the Available Users list and click Add.

    4. The user is added to the Users in Group list. To add multiple users, Ctrl+click each user.

  4. Select Include users in pop-up menus to list users in pop-up menus.

    5. Clear the check box if the user group is intended for users who only report defects and do not need to be assigned any defect actions.

  5. Select Include customers in pop-up menus to list the customers in pop-up menus.

    6. Clear the check box if the user group is intended for customers who only report defects and do not need to be assigned any defect actions.

  6. Click the Command Security tab and set the security for each category.

    7. Be sure to set the commands for each category. TestTrack Pro enables add commands by default. A check mark next to a command means the user group has access to that command. Click the check mark to disable access to a command.

  7. Click the Defect Security tab and set the defect security for the group.
  8. Click the Field Security tab and set field security for this group.

    9. When a new user group or database is created, field security defaults to full security. Users in this group can view and edit every defect field. Be sure to set Add and Edit privileges for all field groups.

    Tip: A field can be represented by an edit box, check box, radio button, or a list box. Remember, setting field security affects all field types.
  9. Click the Notes tab and enter any information about the user group.
  10. Click Add.

    11. The Add User Group dialog box clears and you can add another user group. Click Close when you finish adding user groups.


Viewing user groups

  1. Select the user group on the User Groups list window.
  2. Choose Edit >View User Group or click View on the User Group list window.

    3. The View User Group dialog box opens. All fields are read-only and cannot be edited.

  3. Click OK when you are finished.


Editing user groups

  1. Select the user group on the User Groups list window.
  2. Choose Edit > Edit User Group or click Edit on the User Group list window.

    3. The Edit User Group dialog box opens.

  3. Make any changes and click OK.

    4. Your changes are saved.


Deleting user groups

  1. Select the user group on the User Groups list window.

    2. You can select more than one user group to delete.

  2. Choose Edit >Delete User Group or click Delete on the User Group list window.

    3. You are prompted to confirm the deletion.

  3. Click OK.

    4. The user group is deleted.


Managing Users

Defect, defect, who has the defect?

Users, the people who find, fix and verify defects—who found it, who fixed it, who should be verifying it? By tracking users, TestTrack Pro improves your internal communications and accountability.


About users

TestTrack Pro includes global and local users. Users can be created using the license server admin utility or TestTrack Pro. Global users have access to all databases and can be created using the license server admin utility or in TestTrack Pro. Local users cannot log in to TestTrack Pro and can only be created in TestTrack Pro.

The Users list window provides an overview of the users. In addition, you can add the Available to column to quickly see which users are local and which users are global.

Did you know? What is a local users?
Local users cannot access databases and cannot login to TestTrack Pro. Local users are created when bugs are submitted via SoloBug or SoloSubmit. You can also create local users for tracking purposes. For example, if there is an issue that you need to communicate with a user about, you can add the customer as a local user.


Adding users

  1. Choose Create > User or click Add on the Users list window.

    2. The Add User dialog box opens with the Info tab selected.

  2. Select Local to add the user to the current database. This option creates a local user.
  3. Select Global to add the user to all databases. This option creates a global user, whose demographic information is stored on the license server.
  4. Enter the user information.

    5. You must enter a first and last name. All other information is optional.

    Note: If you add the user to all databases, you must also enter a Username. You can optionally enter a password, which the user can change when they login.
  5. Enter the information on the Info tab.
  6. Click the Notify tab to select email notification options.

    7. Click Configure Rules to configure the user notification rules for each state a defect moves into. See Configuring user notification rules for more information.

  7. Click the CPU tab and enter the CPU information.

    8. These fields are optional but you should enter as much information as possible. Click Capture Config to automatically capture some of the fields, such as operating system and CPU type.

  8. Click the Peripherals tab and enter the peripherals information.

    9. These fields are optional but you should enter as much information as possible.

  9. Click the Notes tab and enter any notes.
  10. Skip the Statistics tab.

    11. This read-only tab contains user statistical information.

  11. Click the Display Settings tab to select the information you want to display on the list windows.

    12. You can control the amount of data displayed by limiting the columns on some, or all, of the list windows. In addition, you can specify a filter for the Defects list window. TestTrack Pro performance can be negatively affected when databases contain a large number of records because it can take a long time for TestTrack Pro to populate the Defects list window. Users cannot change the settings.

    • To filter the Defects list window, select a filter from the Filter menu.
    • To limit which columns display, select a list window from the List Window menu. Select the columns you want to include and click Add. To reorder the columns, select the column and click Up or Down.
  12. Click the Licenses tab to select a license for the user.

    13. If the user is being added to the current database, all fields are disabled.

  13. Click Add.

    14. The user is added.


Adding global users

Global users, which reside on the license server, can be associated with the current database. After a global user is added to the current database, they are displayed in the Users list window. If the user is assigned a named or floating license, they can also login and work with TestTrack Pro.

  1. Choose Edit > Add Global User or click Add Global on the Users list window.

The Add Global Users to Current Database dialog opens.

  1. Select the user you want to add to the current database.

    2. You can select more than one user.

  2. Click Add.

The global user is added.


Configuring user notification rules

Email notifications can be configured for each state defined for defects. Notifications, which are not the same as assignments, simply inform a user of the event change. Notification rules are based on actions and administrator-defined state changes. The notification rules are run to determine if an email should be sent when a defect moves into a corresponding state.


Adding notification rules

  1. Click the Notify tab when you are adding or editing a user.
  2. Click Configure Rules.

The Configure User Notifications Rules dialog box opens.

  1. Click Add.

    2. The Add Notification Rule dialog box opens.

  2. Enter a Rule Name.
  3. Optionally select a Rule Filter.

    4. If a database contains a large number of defects, you may want to filter the defects the rule is applied to. If you need to add filters, see Creating filters.

  4. Select an Email Template.
  5. Select Don’t send email if user made the change if you do not want the user who made the change to receive an email.
  6. Select Only send email if defect is assigned to user if you only want an email sent to the assigned user.
  7. Click OK.

    8. You return to the Configure User Notification Rules dialog. Click Add to add another rule or click OK to return to the User dialog.


Editing user notification rules

After rules are added, you can easily tell how many rules are setup and enabled for an email notification. Select a user and choose Edit > Edit User. Click the Notify tab. If rules are configured for a notification, the number of rules and the number of enabled rules are listed after the notification.

  1. Select the user on the Users list window.
  2. Choose Edit > Edit User or click Edit.
  3. Click the Notify tab.
  4. Click Configure Rules.
  5. Select the rule and click Edit.

    6. The Edit Notification Rule dialog box opens.

  6. Make any changes and click OK.

    7. Your changes are saved.

  7. Click OK again to close the Configure User Notification Rules dialog.


Inactivating user notification rules

Instead of deleting a user notification rule, inactivate it. You can then activate the rule to use it again.

  1. Select the user on the Users list window.
  2. Choose Edit > Edit User or click Edit.
  3. Click the Notify tab.
  4. Click Configure Rules.
  5. Select the rule and click Inactivate.

    6. The rule is no longer active.

  6. Click OK.
  7. Click OK again to close the Configure User Notification Rules dialog.
    8. Note: To activate an inactive rule, select the rule and click Activate.


Deleting user notification rules

Make sure you want to delete the rule. You are not prompted to confirm the deletion and this action cannot be undone.

  1. Select the user on the Users list window.
  2. Choose Edit > Edit User or click Edit.
  3. Click the Notify tab.
  4. Click Configure Rules.
  5. Select the rule and click Delete.

    6. The rule is deleted.

  6. Click OK.
  7. Click OK again to close the Configure User Notification Rules dialog.


Viewing users

  1. Select the user on the Users list window.
  2. Choose Edit >View Users or click View on the Users list window.

    3. The read-only View User dialog box opens. Click the tabs to view the user information.

  3. Click OK to close the View User dialog box.


Editing users

  1. Select the user on the Users list window.
  2. Choose Edit > Edit Users or click Edit on the Users list window.

    3. The Edit User dialog box opens.

  3. Make any changes and click OK.

    4. Your changes are saved.


Duplicating users

If you are adding multiple users with similar information you can save time by duplicating users.

  1. Select the user on the Users list window.
  2. Choose Edit > Duplicate User.

    3. TestTrack Pro duplicates the user, and a number, incrementing by one, appears after the user’s last name. For example, if you duplicate Jane User, a user named Jane User1 is added.

  3. Modify the duplicated user and save your changes.


Promoting users

Local users can be promoted to global users and made available to all databases. Promoting users moves the shared demographic information from the TestTrack Pro server to the license server. When a user is promoted, you can either create an entirely new global user or you can use an existing user record on the license server. For example, a global user named Joseph User is created. A local user named Joe User is also created. These are the same user, with a difference in the first name. Joe User can be promoted as Joseph User. The local user information is discarded and replaced with the global user information.

  1. Select the user on the Users list window.
  2. Choose Edit > Promote User or click Promote on the Users list window.

The Promote to Global User dialog box opens.

  1. Enter a Username.
  2. Select a Promote As user.

    3. If the local user’s first and last name matches an existing global user, that matching user is automatically selected as the Promote As user. The user can also be promoted as a new global user.

  3. Click OK.

    4. The user is promoted.


Making a customer a user

Use this command if you made a mistake and entered a user as a customer.

  1. Select the customer on the Customers list window.
  2. Choose Edit >Make Customer a User.

    3. The customer is transferred to the users list. Assign a username and password add the user to a user group.


Viewing logged in users

Admin: You may not have access to this command depending on your security rights.

You can view the users who are currently logged in to the database.

  1. Choose Activities > Show Logged In Users.

    2. The Logged In Users dialog box opens.

  2. Click Close to close the dialog box.


Logging out users

A user requires a license to run TestTrack Pro. If a user does not exit TestTrack Pro correctly, the license is not released. When this happens, you can free the license by logging out the user. You can also log out users if you need to perform maintenance or make changes that require all users to be logged out.

  1. Choose Activities > Show Logged In Users.

    2. The Logged In Users dialog box opens.

  2. Select the user(s) you want to log out.

    3. To select more than one user, Ctrl+click each user.

  3. Click Log out User(s).

    4. The user(s) is logged out and the dialog box closes. When you log out users, they are notified that their session was dropped by an administrator.


Inactivating users

Inactivate a user to save the historic information. Inactive users cannot login to TestTrack Pro, receive email via TestTrack Pro, or be assigned defects.

  1. Select the user on the Users list window.
  2. Choose Edit > Inactivate User.

    3. You are prompted to confirm the inactivation.

  3. Click Yes.

    4. The user is inactive.


Activating users

  1. Select the user on the Users list window.
  2. Choose Edit >Activate User.

    3. The user becomes active.


Deleting users

You can delete local TestTrack Pro users. Global users cannot be deleted from TestTrack Pro. Global users can be disassociated from the current database, resulting in lost historic information.

Note: Historic information is deleted with the user. To retain historic information, make the user inactive.
  1. Select the user on the Users list window.
  2. Choose Edit >Delete User or click Delete.

    3. You are prompted to confirm the deletion.

  3. Click Yes.

    4. The user is deleted.


Managing Customers

Customers—your most valuable asset!

Keeping your customers happy can be hard to do. TestTrack Pro helps you easily track customers and the issues they report. When a customer calls, you can quickly provide a status update - keeping everyone happy!


About customers

Customers are generally the end-users of your products or services. Unlike users, customers usually do not have access to the database. TestTrack Pro includes global and local customers. Customers can be created using the license server admin utility or TestTrack Pro. Global customers have access to all databases and can be created using the license server admin utility or in TestTrack Pro. Local customers cannot log in to TestTrack Pro and can only be created in TestTrack Pro.

The Customers list window provides an overview of the customers. In addition, you can add the Available to column to quickly see which customers are local and which customers are global.


Adding customers

  1. Choose Create > Customer or click Add on the Customers list window.

    2. The Add Customer dialog box opens.

  2. Select Local to add the customer to the current database. This option creates a local customer.
  3. Select Global to add the customer to all databases. This option creates a global customer, whose demographic information is stored on the license server.
  4. Enter the customer information.

    5. You must enter a first and last name. All other information is optional.

    Note: If you add the customer to all databases, you must also enter a Username. You can optionally enter a password.
  5. Enter the information on the Info tab.
  6. Click the Address tab and enter the address information.
  7. Click the Notify tab to select email notification options.

    8. Click Configure Rules to configure the customer notification rules for each state a defect moves into. See Configuring user notification rules for more information.

  8. Click the CPU tab and enter the CPU information.

    9. These fields are optional but you should enter as much information as possible.

  9. Click the Peripherals tab and enter the peripherals information.

    10. These fields are optional but you should enter as much information as possible.

  10. Click the Notes tab and enter any notes.
  11. Skip the Statistics tab.

    12. This read-only tab contains customer statistical information.

  12. Skip the History Tab.

    13. This read-only tab contains information about defects the customer reported.

  13. Click the Display Settings tab to select the information you want to display on the list windows.

    14. You can control the amount of data displayed by limiting the columns on some, or all, of the list windows. In addition, you can specify a filter for the Defects list window. TestTrack Pro performance can be negatively affected when databases contain a large number of records because it can take a long time for TestTrack Pro to populate the Defects list window. Customers cannot change the settings.

    • To filter the Defects list window, select a filter from the Filter menu.
    • To limit which columns display, select a list window from the List Window menu. Select the columns you want to include and click Add. To reorder the columns, select the column and click Up or Down.
  14. Click the Licenses tab to select a license for the customer.

    15. If the customer is being added to the current database, all fields are disabled.

  15. Click Add.

    16. The customer is added to the database.


Adding global customers

Global customers, which reside on the license server, can be associated with the current database. After a global customer is added to the current database, they are displayed in the Customers list window. If the customer is assigned a named or floating license, they can also log in and work with TestTrack Pro.

  1. Choose Edit > Add Global Customers or click Add Global on the Customers list window.

The Add Global Users to Current Database dialog opens.

  1. Select the customers you want to add to the current database.
  2. Click Add.

The global customers are added.


Searching for customers

Most databases include a large number of customers. Searching provides an easy way to find customers.

  1. Click the Search command button on the Customers list window.

    2. The Find Customer dialog box opens.

  2. Enter the search criteria.
    • Enter full, or partial, first name, last name, and company information.
    • Leave a field blank if you do not want to include it in the search.
  3. Select an option from the Search Options menu.
    • Name/Company begins with this text looks for values beginning with the entered text.
    • Name/Company contains this text looks for values containing the entered text.
  4. Click Find.

    5. Customers that meet the search criteria are displayed in alphabetical order.

  5. Select a customer and click Edit to modify their information.

    6. For more information, see Editing customers.


Viewing customers

  1. Select the customer on the Customers list window.
  2. Choose Edit >View Customer or click View.

    3. The read-only View Customer dialog box opens. Click the tabs to view the customer information.

  3. Click OK to close the View Customer dialog.


Editing customers

  1. Select the customer on the Customers list window.
  2. Choose Edit > Edit Customer or click Edit.

    3. The Edit Customer dialog box opens.

  3. Make any changes and click OK.

    4. Your changes are saved and you return to the Customers list window.


Duplicating customers

If you are adding multiple customers with similar information, save time by duplicating customers.

  1. Select the customer on the Customers list window.
  2. Choose Edit > Duplicate Customer.

    3. TestTrack Pro duplicates the customer, and a number, incrementing by one, appears after the customer’s last name. For example, if you duplicate Joe Customer, a customer named Joe Customer1 is added.

  3. Modify the duplicated customer and save your changes.


Promoting customers

Local customers can be promoted to global customers and made available to all databases. Promoting customers moves the shared demographic information from the TestTrack Pro server to the license server. When a customer is promoted, you can either create a new global customer or you can use an existing customer record on the license server.

  1. Select the customer on the Customers list window.
  2. Choose Edit > Promote Customer or click Promote on the Users list window.

The Promote to Global User dialog box opens.

  1. Enter a Username.
  2. Select a Promote As user.

    3. If the local customer’s first and last name matches an existing global customer, that matching customer is automatically selected as the Promote As customer. The customer can also be promoted as a new global customer.

  3. Click OK.

    4. The customer is promoted.


Making a user a customer

If you make a mistake and enter a user as a customer, you can easily make the user a customer.

  1. Select the user you want to convert to a customer on the Users list window.

    2. You can select more than one user at a time.

  2. Choose Edit > Make User a Customer.

    3. The user is transferred to the customer list.


Deleting customers

Tip: Deleting a customer results in the loss of historic information, such as Reported By or Defect Action records. To save historic information, inactive the customer.
  1. Select the customer on the Customers list window.
  2. Choose Edit >Delete Customer or click Delete on the Customers list window.

    3. You are prompted to confirm the deletion.

  3. Click Yes.

    4. The customer is deleted.


Importing and Exporting Files

Save time…

…when you learn how to import or export XML or text files.


XML import and export

XML import/export is the recommended method for importing and exporting files. This method includes the following advantages over text file import/export:

  • You do not need to match fields when importing or exporting records.
  • You can import and/or export multiple Reported By records.
  • You can import and/or export multiples of the same defect actions.
  • You can import and/or export more than one record type. For example, you can import/export defects and users in a single file.


Importing XML files

Admin: Import security access should be limited to administrative user groups. The misuse of this feature can result in a significant number of unwanted records in your database. The administrator grants access to import/export commands.

With XML, you can quickly import a large amount of data. Email notifications are not sent when you import files; the volume of email messages generated could cause some email servers to crash.

  1. Choose File > Import > XML Import.

    2. The XML Import dialog box opens.

  2. Click Browse to select an XML file to import.

    3. The Open XML File dialog box opens.

  3. Select the file and click Open.

    4. The file you selected is listed in the Import File area on the XML Import dialog box.

  4. Select the Defect Number Import options.
    • Assign the next available defect number automatically assigns the next available defect number for each defect being imported.
    • Import defect number field information imports defect number information from the XML file. If the defect number already exists, an error will be generated and the defect record will not be imported.
      • Note: The Defect Number Import options may be disabled depending on your database options.
  5. Select the Pop-up Menu Item options.

    6. These options apply to pop-up menu fields such as Disposition and Priority and do not apply to user fields.

    • Add the pop-up menu item to the database automatically adds the pop-up menu item to the database.
    • Use the default value uses the default value and ignores any value in the imported XML file.
  6. Click Validate XML File to validate the file.

    7. Validate the XML file before importing the file. Resolving problem(s) before importing is easier than cleaning up data in the TestTrack Pro database.

  7. The XML Import Warnings and Errors dialog box opens, showing the results of the validation testing.

    8. If the XML format is invalid an error will be reported and data will not be imported. Click Save As to save the contents of the Warnings and Errors dialog box as a text file.

  8. If the XML format is valid, click Import.

    9. The XML Import dialog box closes and you return to the list window.

    • When a user field (such as Found By or Fixed By) is imported, TestTrack Pro tries to match the first name and last name with an existing user or customer. If an exact match is not found, the user/customer is created.
    • A defect’s historical data is not imported. The historical data fields are system-generated. The created by and modified by fields are populated with the currently logged in user’s name. The date created and date last modified fields are populated with the current date and time. The creation method field is populated with “XML Import.”
    • When importing, the password field can be either encrypted or in plain text. If TestTrack Pro generated the XML file, the password is encrypted. If a third-party XML file is imported, the password is in plain text.
    • File attachments cannot be imported and/or exported.


Exporting to XML

You can export defects, users, customers, and test configurations to an XML file.

Note: If you only want to export specific defects, you must select the defects before continuing. You can select records from the following list windows: Defects, Users, Customers, and Test Configurations.
  1. Choose File > XML Export.

    2. The XML Export dialog box opens.

  2. Select the type of information you want to export.

    3. To export more than defects, Ctrl+click each record type. For example, Ctrl+click Users and Test Configurations to export this type of information.

    Tip: If you are exporting defect information, you can also export historical log information. This information contains an historical account of changes made to a defect.
  3. Click Export.

    4. The Export XML File dialog box opens.

  4. Select the file location, enter a file name, and click Save.

    5. A progress indicator opens and lets you know the file is being exported.

  5. The Export XML dialog box closes and you return to the list window.
    6. Did you know? All calculated fields for a defect will be exported, but they will not be imported. Calculated fields are exported in case you want to import the XML file into a third-party application. Calculated fields that will be exported for a defect include status and assigned to.

    User statistical data will be exported, but it will not be imported. User statistical data includes the following information: defects found and defects assigned.

    Usernames and passwords are both exported. Usernames are exported in plain text; passwords are always exported as encrypted text.


XML import/export notes

  • If you manually generate XML files or use a third-party application, you can import these XML files into TestTrack Pro. Refer to the TestTrackData.dtd file for proper formatting of your XML file.
  • Do not modify the TestTrackData.dtd file. Modifying this file may result in validation errors or errors importing XML data.
  • Leave elements that you need to set to <“not set”> empty.
  • Control characters cannot be imported into TestTrack Pro and will be removed when exporting text fields. This includes the following:
    Hex Value
    Explanation

    0x01

    Start of Heading

    0x02

    Start of Text

    0x03

    End of Text

    0x04

    End of Transmission

    0x05

    Enquiry

    0x06

    Acknowledge

    0x07

    Bell

    0x08

    Backspace

    0x0B

    Vertical Tabulation

    0x0C

    Form Feed

    0x0E

    Shift Out

    0x0F

    Shift In

    0x10

    Data Link Escape

    0x11

    Device Control One

    0x12

    Device Control Two

    0x13

    Device Control Three

    0x14

    Device Control Four

    0x15

    Negative Acknowledge

    0x16

    Synchronous Idle

    0x17

    End of Transmission Block

    0x18

    Cancel

    0x19

    End of Medium

    • Note: Due to XML specifications, you cannot export an item with a string field containing control characters. There is no way to escape this type of character data.


XML import/export warnings and errors

A warning means the record can be imported but some of the information could not be imported. Following are some of the warning messages that might be displayed as a result of the XML file validation:

  • Could not find match for custom field (applies only to defects).
  • Could not find match for pop-up menu item value.
  • Could not generate custom field value.
  • A default value will be used instead of the specified value.

An error means the record cannot be imported. Following are some of the error messages that might be displayed as a result of the XML file validation:

  • Defect number already exists (applies only to defects and only if using the import defect number field information option).
  • Name already exists (applies only to users, customers, or test configs).
  • Username already exists (applies only to users or customers).
  • Two defects with same defect number in XML file (applies only to defects and only if using the import defect number field information).
  • Two entries with same name in XML file (applies only to users, customers, or test configs).
  • Two entries with same username in XML file (applies only to users or customers).


Text file import and export

You can use TestTrack Pro to import and export records as comma- and tab-delimited text files. You can also import/export files created in other database programs such as FileMaker Pro.

Seapine Software recommends you use XML import/export record information. For more information, see XML import and export.


Importing text files

Note: Import security access should be limited to administrative user groups. The misuse of this feature can result in a significant number of unwanted records in your database. The system administrator grants access to import/export commands.
  1. Choose File > Import > Text File Import.

    2. The Import dialog box opens.

  2. Select the field type you want to import from the Import fields menu.

    3. You can import defect, user, and customer information.

  3. Click Browse to select a file to import.

    4. The Open dialog box opens.

  4. Select the file you want to import and click Open.

    5. The file information appears in the Import dialog box. The column on the left previews the fields as they appear in the file. Click the Previous and Next arrows to move from record to record.

  5. Select the Import options.
    • Select Ignore first record to ignore the first record, which often contains field names.
    • Select Handle quoted text if the program you used to export the records supports quoting fields. When you export a file from a database, quotes are often inserted around comma- and tab-delimited records; otherwise, a comma or tab appearing in a block of text (e.g., a description) would be interpreted as a new record.
    • Select Map vertical tab to return to restore the formatting of multi-line fields. Some applications map carriage returns in multi-line fields to vertical tab characters.
    • Select Tab or Comma Delimiter if either character is used to separate fields.
  6. Match the TestTrack Pro fields in the right column to the fields in the left column.

    7. Click and drag the fields in the right column up or down to the proper position. If you cannot find an exact match, use the closest equivalent.

  7. Select the fields to import.

    8. To select a field, click in the middle column next to the field. A check mark appears next to selected fields. Click again to deselect the field.

  8. Click Import.

    9. A progress indicator opens. Email notifications are not sent when you import files. The volume of email messages generated could cause some email servers to crash.

    Note: Create a text file import template if you are going to import a file using this layout again.


Creating text file import templates

If you import text files with the same field layout often, save the format as a Text File Import Template.

  1. Map the fields as described in Importing text files.
  2. Click Save in the Import Templates area on the Import dialog box.

    3. The Save Import Template dialog box opens.

  3. Select the file location, enter a file name, and click Save.

    4. The Import Template is saved. You return to the Import dialog box.


Using text file import templates

  1. Choose File > Text File Import.

    2. The Import dialog box opens.

  2. Click the Load button in the Import Templates area on the Import dialog box.

    3. The Load Import Template dialog box opens.

  3. Select the Import Template and click Open.

    4. The template is loaded. You return to the Import dialog box.


Exporting to text files

Note: To export just a few records, select the records on the list window now. You can select records from any list window.
  1. Choose File > Text File Export.

    2. The Export dialog box opens.

  2. Select the field type you want to export from the Export fields menu.

    3. If you have a Text File Export Template that matches the file format, load it now and skip the following steps.

  3. Select the fields to export.
    4. Note: If you want to export all fields, click Check All. If you want to deselect all fields, click Check None.
  4. Repeat steps 2 and 3 for all record types.
  5. Select the Export options.
    • Select Export selected records only to only export records selected in the list window.
    • Select Include column headings to export the column headings.
    • Select Convert EOLs to spaces to convert carriage returns/line feeds to spaces. This simplifies importing multi-line fields (e.g., defect description) into programs that do not handle fields with embedded carriage returns correctly such as Microsoft Excel.
    • Select Tab or Comma Delimiter to insert the character between fields.
      • Note: If you are going to export a file using this layout again, save this format as a Text File Export Template.
  6. Click Export.

    7. The Export file dialog box opens.

  7. Select the file location, enter a file name, and click Save.

    8. A progress indicator opens and lets you know the file is being exported.


Creating text file export templates

If you export text files with the same field layout often, save the format as a Text File Export Template.

  1. Set up the fields as described in Exporting to text files.
  2. Click the Save button in the Export Templates area on the Export dialog box.

    3. The Save Export Template dialog box opens.

  3. Select the file location, enter a file name, and click Save.

    4. You return to the Export dialog box.


Using text file export templates

  1. Choose File > Text File Export.

    2. The Export dialog box opens.

  2. Click the Load button in the Export Templates area on the Export dialog box.

    3. The Load Export Template dialog box opens.

  3. Select the Export Template and click Open.

    4. The template is loaded and you return to the Export dialog box.


Customizing Email Templates

Give your users the information they need!

Customize email templates to keep your users and customers up-to-date!


About email templates

Email templates are used to standardize email messages sent to users and customers who request email notifications and for sending confirmations to users/customers who submit items via email.

TestTrack Pro email templates can be used as provided or the template contents can be customized. You can customize the templates by using field codes, entering text, or a little of both.

Email templates support field codes, sequences of characters and letters that TestTrack Pro replaces with corresponding data from the database. For example, %CREL% is replaced with the method used to create the defect (e.g., SoloBug import).

Note: includes a complete list of field codes supported by TestTrack Pro.


Adding email templates

Note: Any field added to an email template can be viewed by all email recipients, regardless of field level security settings.
  1. Choose Configure > Email Message Templates.

    2. The Edit Email Templates dialog box opens.

  2. Click Add.

The Add Email Template dialog opens.

  1. Enter a Name and Description.
  2. Enter a Subject.

    3. You can enter text and use field codes to customize the subject line. For example, to use the defect number in the subject field, enter %DNUM%.

  3. Enter the message body.

    4. You can enter text and use field codes to customize the template. When you customize a template, any spaces and lines that you add are saved with the template. As you type, text is automatically wrapped to the next line. When an email message notification is sent, all field codes are automatically replaced with the corresponding data from the TestTrack Pro database.

  4. Select a Template Access option.
    • Select All users can view this template if you do not want to restrict users from receiving the template.
    • Select Only allow users in the following groups to view this template then choose user groups to restrict the template. This option provides template security because the email is only sent to users in the selected groups.
  5. Select a Recipient List option.
  6. Click OK.

    7. The email template is added.


Editing email templates

  1. Choose Configure > Email Message Templates.

    2. The Edit Email Templates dialog box opens.

  2. Select an email template and click Edit.
  3. Make any changes.
  4. Click OK.

    5. The changes are saved.


Deleting email templates

  1. Choose Configure > Email Message Templates.

    2. The Edit Email Templates dialog box opens.

  2. Select an email template and click Delete.

    3. You are prompted to confirm the deletion.

  3. Click Yes.

    4. The template is deleted.


Working with SoloBug

Simplified customer bug reporting!

SoloBug is a stand-alone bug reporting application that works with TestTrack Pro. SoloBug lets customers submit defects directly to TestTrack Pro.


About SoloBug

SoloBug includes the following benefits:

  • Eliminates data entry of bug reports and feature requests by automatically importing bug reports into TestTrack Pro. When TestTrack Pro receives an email with a SoloBug file, it is automatically added to your database.
  • Limits customers to your bug reporting terminology, saving data entry time.
  • Captures customers’ computer information, making it easier to track configuration-specific issues.
  • Lets your customers and users include file attachments with bug reports and feature requests.

What are SoloBug files?

A SoloBug file contains a single bug report, or feature request, created by customers and users. The SoloBug file is emailed to an address you specify. You can import the file into any TestTrack Pro database. A SoloBug file contains:

  • The customer’s or user’s personal information and computer setup.
  • A description of the problem or feature request.
  • Any additional data or files attached to the SoloBug file.


Customizing SoloBug for Windows

Before distributing SoloBug, customize the executable to make sure customers and users provide all the information you need. You can customize such things as the title, instructions, or field names. You can also rename fields, add field values, and make fields required.

Note: To make sure the correct SoloBug executable is distributed for each database, copy and rename the executable to match the database name.
  1. Start TestTrack Pro and login to the database you want to customize SoloBug for.
  2. Choose Configure > Customize SoloBug for Windows.

    3. The Customize SoloBug for Windows dialog box opens.

  3. Click Browse to select the SoloBug executable you want to customize.

    4. The Open SoloBug Application dialog box opens.

  4. Select a SoloBug executable and click Open.
  5. You return to the Customize SoloBug for Windows dialog box, with all fields populated.
  6. Enter the General SoloBug Settings.
    • Title appears in the title bar of the SoloBug application, preceding the name of the open bug report file.
    • File Name Prefix becomes the first part of the SoloBug file name. The remaining portion of the bug report file name is a sequence number SoloBug generates to distinguish one file from another. This field can help you visually organize SoloBug files. For example, if you customize SoloBug for three different products, you can enter the product name in the File Name Prefix field.
    • Instructions provide users with information specific to your use of SoloBug, such as the email address you want the files sent to. Instructions are not displayed if this field is empty.
  7. Customize the fields and select field options.

    8. If you customize field names, the customized name is listed. For example, Element is displayed if you rename Component to Element.

  8. Click Use Database Settings to synchronize the information in the SoloBug executable with the TestTrack Pro database settings.

    9. Selecting this option customizes all fields in the Field to Customize list.

    Note: If you use the database settings, required fields, field names, and field values are synchronized with the TestTrack Pro database.
  9. To customize a field, select the field from the Field to Customize list.

    10. This example uses the Severity field. The field name changes based on the selected field.

  10. The field is visible is selected by default.

    11. Clear the check box to make the field and its label invisible.

  11. Select User is required to select a value for the field to make this field required.

    12. The SoloBug file cannot be saved until values are entered for all required fields.

  12. Select User can enter a free form text entry in the field to let users enter a value for this field.
  13. To rename the field, enter the new name in the text box.

    14. The values in the Field to Customize list are populated from the TestTrack Pro database. The In SoloBug, the...field is named value is populated from the SoloBug executable and may not match the Field to Customize selection.

  14. The default field values appear in the Field Values list.

    15. You can add, edit, or delete any field value. To reorder the values, click the arrow next to the field and drag it up or down to a new position.

  15. When you finish configuring field names and values, click Update SoloBug & Close.

    16. TestTrack Pro modifies the SoloBug executable. The following message opens:

  16. Click OK.

    17. The customized SoloBug executable is ready for distribution.


Customizing SoloBug for Palm OS

SoloBug for Palm OS lets your users and customers easily submit bug reports and feature requests. You can customize such things as the title, instructions, and field names. In addition, you can rename fields, add field values, and make fields required. You can also provide a customized SoloBug database for each customer.

  1. Start TestTrack Pro and login to the database you want to customize SoloBug for.
  2. Choose Configure > Customize SoloBug for Palm OS.

    3. The Customize SoloBug for Palm OS dialog box opens.

  3. Select Create new Palm OS configuration database to create a new configuration database. Skip to step 5 to continue customizing the configuration database.
  4. Select Edit existing Palm OS configuration to edit a configuration database.
  5. Click Browse to select a Palm configuration database.

    6. The Open Palm OS SoloBug Configuration Database dialog box opens.

  6. Select the database you want to edit and click Open.

    7. You return to the Customize SoloBug for Palm OS dialog box, with all fields populated.

  7. Enter the General SoloBug Settings.
    • Title appears in the title bar of the SoloBug application, preceding the name of the open bug report file.
    • File Name Prefix becomes the first part of the SoloBug file name. The remaining portion of the bug report file name is a sequence number SoloBug generates to distinguish one file from another. This field can help you visually organize SoloBug files. For example, if you customize SoloBug for three different products, you can enter the product name in the File Name Prefix field.
    • Instructions provide users with information specific to your use of SoloBug, such as the email address you want the files sent to. Instructions are not displayed if this field is empty.
  8. Customize the fields and select field options.

    9. If you customize field names, the customized name is listed. For example, Element is displayed if you rename Component to Element.

  9. Click Use Database Settings to synchronize the information in the SoloBug executable with the TestTrack Pro database settings.

    10. Selecting this option customizes all fields in the Field to Customize list.

    Note: If you use the database settings, required fields, field names, and field values are synchronized with the TestTrack Pro database.
  10. To customize a field, select the field from the Field to Customize list.

    11. This example uses the Severity field. The field name changes based on the selected field.

  11. The field is visible is selected by default.

    12. Clear the check box to make the field and its label invisible.

  12. Select User is required to select a value for the field to make this field required.

    13. The SoloBug file cannot be saved until values are entered for all required fields.

  13. Select User can enter a free form text entry in the field to let users enter a value for this field.
  14. To rename the field, enter the new name in the text box.

    15. The values in the Field to Customize list are populated from the TestTrack Pro database. The In SoloBug, the...field is named value is populated from the SoloBug executable and may not match the Field to Customize selection.

  15. The default field values appear in the Field Values list.

    16. You can add, edit, or delete any field value. To reorder the values, click the arrow next to the field and drag it up or down to a new position.

  16. Click Save when you finish customizing the configuration database.
    • If you are creating a new database, the Save Palm OS SoloBug Configuration Database dialog box opens. Enter a file name and click Save.
    • If you are editing an existing database, your changes are automatically saved.
  17. The customized SoloBug executable is ready for distribution.


Distributing SoloBug

You can distribute SoloBug to customers, users, beta sites, etc. Refer to the SoloBug license included with TestTrack Pro for rules governing distribution of SoloBug applications. SoloBug is available for Windows, Macintosh, and the Palm OS.

SoloBug comes with a user guide you can edit and distribute. Every topic in the guide is included in the online Help, so you do not need to distribute the hard copy with SoloBug. You may want to customize the guide to include your company’s name, email addresses, URLs, etc.


Customizing the SoloBug user guide

SoloBug comes with a user guide you can edit, print, copy, and distribute. Every topic in the guide appears in the online Help, so you do not need to distribute the hard copy with SoloBug. You may want to customize the guide with your company’s name, email, URLs, etc.

Note: Make a backup copy of the SoloBug user’s guide before you customize it!

The following SoloBug user files are located in the TestTrack Pro folder:

  • Solobug.doc the SoloBug user guide in Microsoft Word format.
  • Solobug.pdf the SoloBug user guide in Adobe Acrobat Reader format.
  • Solobug.hlp the SoloBug Help file. The Help file cannot be customized.


Automatically importing SoloBug files

  1. Choose Edit > Options > Database Options.

    2. The Database Options dialog box opens.

  2. Click the SoloBug tab and select the import options.


Overriding SoloBug automatic import settings

When you set the automatic import options, you select the interval you want TestTrack Pro to look for new SoloBug files; you can override this update interval at any time.

  1. Choose File > Import > Perform Server Import.

    2. The server checks for, and imports, new SoloBug files.


Manually importing SoloBug files

  1. Choose File > Import > Load SoloBug Files.

    2. The SoloBug Files to Import dialog box opens.

  2. Select the SoloBug file(s) you want to import.

    3. Remember, SoloBug files are saved with the .sbg extension.

  3. Click Open.

    4. The imported file(s) appears in the Defects list window at the end of the list. Notice the new defect icon appears next to it.

    Note: You can also drag and drop the SoloBug file onto the Defects list window.


Field Codes Reference

Use field codes to automatically generate data!

This appendix includes a list of all field codes. Field codes return the corresponding information from the database. For example, the sequence %DATS% is replaced with the current date format. The sequence %DNUM% is replaced with the defect number.


About field codes

Field codes are used to build customized email messages that provide information specific to the defect that triggered the notification or, in the case of an email acknowledgment, was imported via email. If you are creating an ad hoc report, you can use field codes to include specific database information for the report. You can also use field codes to build personalized SoloSubmit Web pages that provide information specific to your company and your customers’ use of SoloSubmit.


Field codes

Field Code | Description
%ASSB% | The user who made the defect assignment.
%ASSD% | The date the defect was most recently assigned.
%ASST% | The user to which the defect is assigned.
%ASSN% | The most recent defect assignment notes.
%CLSB% | The user who closed the defect.
%CLSD% | The date the defect was closed.
%CLSN% | The notes about closing the defect.
%CLSR% | The close resolution.
%CHNG% | The changes to the defect (only applies to Defect Changed notification).
%CMTA% | All of the defect's comments.
%CMTL% | The most recent defect comment.
%COMP% | The component containing the defect.
%CREB% | The user who was logged in when the defect was created.
%CRED% | The date the defect was created.
%CREL% | The method used to create the defect (e.g., SoloBug import).
%CUEM% | The currently logged in user's email address (does not apply to Email Acknowledgement notification).
%CUSR% | The currently logged in user's first and last name (does not apply to Email Acknowledgement notification).
%DATL% | The current date in long date format (mmmm, dd yyyy).
%DATS% | The current date in short date format (mm/dd/yy).
%DESC% | The first defect description.
%DISP% | The defect's disposition.
%DNUM% | The defect’s number.
%DOCA% | Whether the most recent defect fix affects documentation.
%ENTB% | The user who entered the defect.
%ENTD% | The date the defect was entered.
%ESTB% | The user who most recently estimated the defect fix.
%ESTD% | The date of the most recent defect estimate.
%ESTE% | The most recent estimated effort to fix the defect.
%ESTN% | The notes of the most recent defect estimate.
%ESTV% | The defect's most recent estimated fix version.
%ESTW% | The defect’s most recent estimated fix date.
%FILE% | The database’s file name.
%FIXB% | The user who most recently fixed the defect.
%FIXD% | The date the defect was most recently fixed.
%FIXN% | The most recent notes about fixing the defect.
%FIXS% | The Fix Verify/Close value from the most recent fixed action.
%FIXT% | The total time required to fix the defect.
%FIXV% | The version in which the defect was fixed.
%FNDB% | The person who found the defect.
%FNDD% | The date the defect was found.
%FNDV% | The version in which the defect was found.
%MODB% | The user who last modified the defect.
%MODD% | The date the defect was last modified.
%NUMR% | The number of users and customers reporting the defect.
%PRIO% | The defect’s priority.
%PRNM% | The Project Name field in the Project Info dialog.
%PROD% | The product containing the defect.
%REFR% | The defect’s reference field.
%RELB% | The person who created the release notes.
%RELD% | The date the release notes were created.
%RELH% | Whether the defect has release notes.
%RELN% | The defect’s most recent release notes.
%RELV% | The version in which the defect fix was released.
%REPR% | The defect’s reproducible status.
%RESO% | The defect’s fix resolution.
%SEQN% | The sequence number associated with the defect (applies only to Email Acknowledgment notification).
%SEVR% | The defect’s severity.
%STAT% | The defect’s status.
%STEP% | The steps to reproduce the defect.
%SUMM% | The defect’s summary.
%TCFG% | The defect’s test configuration name.
%TPLA% | Whether the most recent defect fix affects the test plan.
%TYPE% | The defect’s type.
%VERB% | The user who most recently verified the defect.
%VERD% | The date the defect was most recently verified.
%VERN% | The most recent notes about verifying the defect.
%VERV% | The version in which the defect was verified.
%VPAS% | The Verify Pass/Close value from the most recent verify action.
%WORK% | The defect’s workaround.
%WRKH% | Whether the defect has a workaround.
%_Z...% | Custom field code.

Label field codes

TestTrack Pro lets you rename defect field labels. The renamed field labels have corresponding field codes. These field codes return the field label, not the field data.

Field Code | Field Name
%DFUS_L% | Defect - upper case, singular
%DFUP_L% | Defects - upper case, plural
%DFUM_L% | Defect(s) - upper case, singular/plural
%DFLS_L% | defect - lower case, singular
%DFLP_L% | defects - lower case, plural
%DFLM_L% | defect(s) - lower case, singular/plural
%SUMM_L% | Summary Type
%TYPE_L% | Type
%DISP_L% | Disposition
%PRIO_L% | Priority
%PROD_L% | Product
%COMP_L% | Component
%REFR_L% | Reference
%SEVR_L% | Severity
%ENTB_L% | Entered by
%ENTD_L% | Date Entered
%STAT_L% | Status
%FNDB_L% | Found by
%FNDD_L% | Date Found
%DATE_L% | Date
%FNDV_L% | Version Found
%VERS_L% | Version
%DESC_L% | Description
%REPR_L% | Reproduced
%STEP_L% | Steps to Reproduce
%TCFG_L% | Computer Config
%HWSW_L% | Other Hardware and Software
%CFTB_L% | Custom Field tab

Did you know? Remember, renamed label field codes only return the label name and not the field data. For example, you rename Reference to Case Number. You customize an email template to notify managers of a problem, including the case number in the subject line. In the subject line of the template, enter %REFR_L%: %REFR%. When a manager is sent an email, the subject line includes: Case Number (label): case number (data).


Field code notes

  • All dates use system-defined date formats. TestTrack Pro uses the short-date style of the Regional Settings Properties defined in the Windows operating system.
  • To include a percent sign (%) in the body of a message, include two percent signs in a row (e.g., “%%”).
  • Email notifications support field codes in the email subject line. You can include personalized subjects such as Re:%SUMM% which expand to include the defect’s summary field in the email’s subject.


Defect Fields Reference

About Defect Fields

This appendix includes tables that define every defect field and lists whether they can have default values or if they can be set as required fields. For more information, see Defining required fields and default values.


Defect record

The following table lists the fields that are part of the defect record.

Field name | Set default value? | Initial default value | Configure as required? | Initially configured as required?
Summary | no | NA | yes | yes
Status | no | NA | no | NA
Type | yes | <not set> | yes | yes
Product | yes | <not set> | yes | no
Reference | no | NA | yes | no
Entered by | yes | <current user> | yes | yes
Disposition | yes | <not set> | yes | no
Priority | yes | <not set> | yes | no
Component | yes | <not set> | yes | no
Severity | yes | <not set> | yes | no
Date Entered | yes | <current date> | yes | no
Custom fields (pop-up menu) | yes | <not set> | yes | no
Custom fields (edit box) | no | NA | yes | no
History | no | NA | yes | no
Workaround | no | NA | yes | no
Notify | no | NA | no | NA


Found by record in a defect

The following table lists the fields that are part of the found by record in a defect. The default values are used every time a new found by record is created in the defect. The fields marked as required must be filled in for every found by record in the defect.

Field name | Set default value? | Initial default value | Configure as required? | Initially configured as required?
Found by | yes | <current user> | yes | yes
Date Found | yes | <current date> | yes | no
Version Found | yes | <not set> | yes | no
Description | no | NA | yes | no
Reproduced | yes | <not set> | yes | no
Steps to Reproduce | no | NA | yes | no
Computer Config | yes | “User Config” | yes | no
Other HW & SW | no | NA | yes | no
Attachments | no | NA | no | NA


Defect assignment record

The following table lists the fields that are part of the defect assignment record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Assign to | yes | <blank> | yes | yes
Assigned by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Notes | no | NA | yes | no


Estimate to fix record

The following table lists the fields that are part of the estimate to fix record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Estimated by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Estimated effort | no | NA | yes | no
Completion date | yes | <not set> | yes | no
Completion version | yes | <not set> | yes | no
Assumption | no | NA | yes | no


Fix defect record

The following table lists the fields that are part of the fix defect record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Fixed by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Version | no | NA | yes | no
Resolution | yes | <not set> | yes | yes
Hours to fix | no | NA | yes | no
Affect documentation | yes | not checked | no | NA
Affect test plan | yes | not checked | no | NA
Notes | no | NA | yes | no


Release to testing record

The following table lists the fields that are part of the release to testing record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Released by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Notes | no | NA | yes | no


Verify defect record

The following table lists the fields that are part of the verify defect record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Verified by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Version | yes | <not set> | yes | no
Pass or fail | yes | Pass and close | no | NA
Notes | no | NA | yes | no


Release to customer testing record

The following table lists the fields that are part of the release to customer testing record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Released by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Notes | no | NA | yes | no


Customer verify defect record

The following table lists the fields that are part of the customer verify defect record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Verified by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Version | yes | <not set> | yes | no
Pass or fail | yes | Pass and close | no | NA
Notes | no | NA | yes | no


Re-open defect record

The following table lists the fields that are part of the re-open defect record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Re-opened by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Notes | no | NA | yes | no


Close defect record

The following table lists the fields that are part of the close defect record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Closed by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Notes | no | NA | yes | no


Defect comments record

The following table lists the fields that are part of the defect comments record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Commented by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Notes | no | NA | yes | no


Release notes record

The following table lists the fields that are part of the release notes record.

Field name | Set default value? | Initial default value selection | Configure as required | Initially configured as required?
Released by | yes | <current user> | yes | yes
Date | yes | <current date> | always | NA
Notes | no | NA | yes | no